

extensions[profiler]

globals
[run-number;;Holds the number of run the user has performed


plot-it ;tells the plot when to run

color-world      ;;so you can easily change the color of the world

post-synaptic ;;make all colored patches below the origin known as post-synaptic
post-membrane ;;the set of postsynaptic patches that touch the gap and give rise to channels
f1 f2;;foci 1 and 2 for the ellipse used in drawing the world
Particles ;; a global grouping the moving turtles
;PSP-count;;count the PSPs occurring within a time frame
cleared ;;boolean to help make sure the world has been cleared before each run
binding-count  ;;count number of bound receptors
penc];color of pen for histogram

patches-own
[
PSP-ready  ;THIS IS AN ADDED BOOLEAN THAT TELLS AN ENTERING ION IF THE PATCH HERE BELONGS TO POST-SYNAPTIC
psp ;;variable that determines the color they will flash
r1 r2 total ;;variables used during setup to define location relative to ellipse
occupied ];;used to determine whether an element is already at that location during setup

turtles-own 
[
r-position] ;;used to place moving turtles within the gap

breed [NTs NT] ;;neurotransmitter breed
breed [channels channel] ;;receptors in postsynaptic membrane
breed [nas na] ;;sodium ions
breed [att-ions att-ion];;ions attracted by a receptor
breed [enzymes enzyme]
breed[NCs NC] ;non-competitives are a breed

channels-own
[partner ;a ligand
 bound-NC;the NC antagonists
my-PSP ;all the patches that ampa owns
open ; a boolean that detects of channel is open
open-time;the time the channel stays open
state] ;whether unbound (0), bound by NT(1), agonist(2) or antagonist(3) or bound by NC antagonist(4)

NTs-own 
[
bound   ;;boolean tells whether or not the nt is attached to the channel
partner ;;once an NT is bound to a receptor it partners with it
active] ;; whether the NT is in active state or not (boolean)

NCs-own
[bound-time
  
  partner
  active]

att-ions-own [
fired ;;THIS IS A BOOLEAN THAT IS SET TO TRUE ONCE THE ION CROSSES INTO POST-SYNAPSE
in-time];;time attracted ions are allowed to remain within a structure... 
;;...before they are returned to the gap. 

enzymes-own[
partner
block-time]

;;;;;;;;;;;;;;;;;;;;;;;;;;RUN-TIME PROCEDURES;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
to Run-Simulation
profiler:stop          ;; stop profiling
ifelse cleared = true ;;if user has cleared the remaining particles from last run
 [if ticks = 0[ ;;run these commands once at the start of every run
    set Particles turtles with [breed = nas or breed = enzymes or breed = NCs]
    inject  set binding-count 0]
    
    go
    
  if ticks = 3000 [Stop-procedures stop] ;;end run manually if it goes too long
  if count nts with [active = true and color = green] = 0 [Stop-procedures stop]] ;;if no more active NTs, stop
 [user-message (word "Please hit 'Clear Particles'") stop] ;;remind user to clear particles before each new run
end

to go
tick ;;increase clock at every iteration

ask Particles [move] ;;asks ions and enzymes to move
                           
;;The following two statements are needed because neither NTs nor att-ions are in place at time zero                           
ask NTs [if partner = nobody [move]] 
ask att-ions[move]
ask att-ions  [check-fire] ;;ONLY NAS ATT-IONS RUN PROCEDURE
ask channels [ monitor-binding 
               control-receptors  ;;control the opening and closing of receptors 
               recolor];let the flashes get back to blue

remove-NTs;;inactive NTs are killed of one-by-one every 100 iterations
remove-NCs

ask enzymes with [shape = "enzyme"] [inactivate-nts inhibit-enzymes] ;;works well
                                                      

end


to Stop-procedures

set plot-it true

ask patch -5 -35[set plabel-color yellow set plabel "Hit 'Clear Particles' before starting a new run" ]
reset-ticks

set cleared false

output-print (word "Run " run-number " : NTs")
if  profiler:calls "add-agonists" > 0
[output-print  "+ agonists"]
if  profiler:calls "add-antas" > 0
[output-print  "+ antagonists"]
if  profiler:calls "make-noncomp-antagonists" > 0
[output-print  "+ non competitive antagonists"]
if  profiler:calls "make-enzyme-antagonists" > 0
[output-print  "+ enzyme antagonists"]
profiler:reset
output-print (word "Total PSPs: " binding-count)
set run-number run-number + 1
end

to Clear-Particles
profiler:start
ask NTs[die]
ask NCs [die]
ask enzymes[ifelse shape = "anta-enz" [die] [random-position]]
ask channels [set size 20 
              set color red 
              set partner nobody 
              set shape "receptor" 
              set open false 
              set state 0
              set open-time 0]
ask patches [set plabel-color color-world]
set penc 1
set plot-it false
set cleared true
end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;MOVING TURTLE PROCEDURES;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;Procedure move controls the motion of all turtles that move. 
to move
if breed = NTs or breed = NCs
  [if partner != nobody [stop] ];;if bound-NT, quit the procedure
  
bounce ;;look ahead one patch and see whether you need to turn your heading

fd 0.1

if breed = att-ions and [total] of patch-here > 170 [Pop-out] ;if within the cell, get back to synaptic gap
end



to bounce
 let new-patch patch-ahead 1
 if new-patch = nobody [random-position stop] 
 ;;the next two statements prevent particles from moving too close to limits of world
 if [pycor] of new-patch > max-pycor - 3 [set heading (heading - 175 - random 30)]   
 
 if [pxcor] of new-patch > max-pxcor - 3 or [pxcor] of new-patch < min-pxcor + 3 [set heading (heading - 150 - random 60)]
 
 ;;attracted ions only go through if their 'inside' flag is false
 if breed = att-ions [stop]
 ;we use larger or equal to color world because the PSP flash tends to allow particles in
 if [pcolor] of new-patch >= 104  [set heading (heading - 150 - random 60)] 
 if [pcolor] of patch-here = color-world [random-position] 
end


;;let ions come into structure and live for 20 iterations. Then place back in extracellular space
to Pop-out
if ticks > in-time + 5  
     [set breed nas set r-position 2 random-position]
     
end

;;//////////////////////////////////////BINDING PROCEDURES//////////////////////////////////////////////////////

to monitor-binding
  
  if state = 0 or state = 4 [attract] ;unbound with or without NCs attract
  
  if state = 1 or state = 2
       [if ticks > open-time + 40 [open-up stop] ];;if already have a partner for 40 iterations, open the pore and stop attracting
       
       if state = 3
       [if ticks > open-time + 400 [unbind-NT]];;only antas need this as channels never open their pore
       
  if any? NCs [;Only if there are NCs around 
    
    ifelse state <= 3 ;if the channel is not bound by and nc already
     [attract-NCs]
     [check-NCs]
  ]                                      
end

to attract

               
 if any? NTs in-cone 8 60 with [active = true] ;; grab a partner
         [set partner one-of NTs in-cone 8 60 with [active = true] 
          ask partner [bind] ;;ask ligand to hide
          determine-state
          set-shape
          
          if state = 1 or state = 2 ;if you have been bound by an NT or agonist ALONE
          [set open-time ticks] ;;get your counter running

         ]
          
 end

to check-NCs
  ifelse bound-NC != nobody[ 
                       
                          ifelse ticks > ([bound-time] of bound-NC) + 800
                               [if state >= 5 [unbind-NT] unbind-NC set state 0 set-shape set bound-NC nobody] 
                               [stop]
                       ]
                        
  [stop]
  
end

;THis procedure runs only if there are any NCs about
to attract-NCs
  
   if any? NCs in-cone 8 90 with [active = true] ;; grab a partner
         [set bound-NC one-of NCs in-cone 8 90 with [active = true] 
          ask bound-NC [bind set bound-time ticks] ;;ask ligand to hide and stay put
          set open false;make sure you don't let ions in
          determine-state
          set-shape]
          
end

;this method allows the channel to determine its state in order to know which
;shape it should take and whether it should open or stay closed
to determine-state
  let val  0
  let value 0
  
  ifelse bound-NC != nobody ;if an NC is bound
  [set val 4];;add four to state
  [set val 0]
  
  if partner != nobody ;if you have a partner
   [
    ifelse [color] of partner = green ;if bound to an NT
    [set value 1] 
    [
       ifelse [color] of partner = yellow ;;or an agonist
        [set value 2]
        [
          if[color] of partner = cyan ;or an antagonist
          [set value 3 set open-time ticks] 
          
  
        ]]]
   
   set state val + value
  
end
        
to set-shape
  if state = 0 [set shape "receptor" set color red]
  if state = 1 [set shape "bound-receptor"]
  if state = 2 [set shape "bound-agonist" set color yellow]
  if state = 3 [set shape "bound-agonist" set color cyan]
  if state = 4 [set shape "nc-agon-receptor" ]
  if state = 5 [set shape "nc-agon-receptor-bound-nt" set color green]
  if state = 6 [set shape "nc-agon-receptor-bound-ant" set color yellow]
  if state = 7 [set shape "nc-agon-receptor-bount-ant" set color cyan]
  
end


;;this procedure asks the NTs and other particlesto hide when bound
to bind
set partner myself ;;set me as your partner

set hidden? true
setxy [xcor] of myself [ycor] of myself
end



to unbind-NC
  ask bound-NC[
set color magenta
set active false
set hidden? false
set partner nobody
set heading 30 - random 15
fd 3]
end

;;Make sure all NT variables are set to inactive form and receptor variables are completely reset
to unbind-NT
    ask partner [set color magenta
                 set hidden? false
                 set active false
                 set heading  30 - random 15 ;;make NT float upwards
                 fd 3 ;to not get stuck on membrane
                 set partner nobody ]  
    set open false set size 20 set open-time 0 
    if state <= 3 [set state 0] ;make sure you set the right
    if state >= 5 [set state 4];shape
    set-shape
    set partner nobody        
end

;/////////////////////////////////////ENZYME PROCEDURES/////////////////////////////////////////

;;ENZYMES SELECT AN NT MOLECULE AND ASK IT TO MOVE ALONG FOR A SHORT TIME
to inactivate-nts
  ifelse partner != nobody ;if enzyme already has a partner
  
     [
       ifelse ticks > block-time + 500 ;if block time has passed
            [ ask partner [set partner nobody]
              set partner nobody set block-time 0 
             ];;release partner, reset vars
      
             ;otherwise maintain partner along
            [let lookinat [heading] of self ;save heading of enzyme
             let x-cor [xcor] of self ;save my x..
             let y-cor [ycor] of self;..and y cors
             ask partner[
                     set heading lookinat ;;and become inactive
                     setxy x-cor y-cor]];and keep on
     ]
  
     [if any? NTs with [color = green and partner = nobody] in-radius 4 ;if there are any NTs in radius 4 
       [
        let lookinat [heading] of self ;save heading of enzyme
        let x-cor [xcor] of self ;save my x..
        let y-cor [ycor] of self;..and y cors
       
        set partner one-of NTs with [color = green] in-radius 5 ;set as partner one of the NTs around
        set block-time ticks ;save the iteration as time zero
        ask partner[
                     set partner myself
                     set heading lookinat ;;and become inactive
                     setxy x-cor y-cor 
                     set color magenta 
                     set active false]]]
end

to inhibit-enzymes
 if partner = nobody[
 
     ifelse any? enzymes in-radius 5.5 with [shape = "anta-enz" and partner = nobody and color = 85] 
                       [let lookinat [heading] of self
                        let x-cor [xcor] of self
                        let y-cor [ycor] of self
                      
                        let pner self
                        set partner one-of enzymes in-radius 5.5 with [shape = "anta-enz" and partner = nobody and color = 85]
                        set block-time ticks
                        ask partner [
                             set partner pner 
                             set heading lookinat 
                             setxy x-cor y-cor
                             set block-time ticks ]]
                             
                       [stop]]
 end
   

   
;;//////////////////////////////////ELIMINATION PROCEDURES//////////////////////////////////

;;Remove one of the inactive NTs every 300 iterations that is not partnered with an enzyme
to remove-NTs
  
if ticks mod 300 = 0 [if any? NTs with [partner = nobody and active = false and hidden? = false]
                     
  [ask one-of NTs with [partner = nobody and active = false and hidden? = false ] [die]]]

end

to remove-NCs
  
if ticks mod 300 = 1 [if any? NCs with [partner = nobody and active = false and hidden? = false]
                     
  [ask one-of NCs with [partner = nobody and active = false and hidden? = false ] [die]]]

end

;;/////////////////////////////////////CHANNEL PSP PROCEDURES////////////////////////////////////////////

to check-fire
if fired = true [stop] ;;if you have already fired, stop

ask patch-here [if PSP-ready = true[ ;;else if the patch where you find yourself is postsynaptic
    ask channels in-radius 8 [fire-PSP]]];;ask the ampa receptor close-by to fire
    
if [pcolor] of patch-here != black ;;if you are within the membrane
[set fired true   ;;set fired to true
 ] 
end

;;This procedure draws the PSP flash by increasing variable psp on the
;;postsynaptic patches surrounding the ampa receptore
to fire-PSP
   ask my-PSP in-radius 8 [set psp psp + .75]  ;AMPAS WILL LAY DOWN PSP
   ask my-PSP in-radius 6 [set psp psp + 1 ]
   ask my-PSP in-radius 4 [set psp psp + 2 ]
   ask my-PSP in-radius 2 [set psp psp + 4 ]
   ask my-PSP in-radius 1 [set psp psp + 5 ];]
   ask my-PSP [set PSP-ready true]
end

;;"Evaporate" the variable psp to recolor the postsynaptic structure after a flash
to recolor ;;WHEN THERE ARE IONS ON THE AMPA'S PATCHES WE WILL RUN THIS
if any? my-PSP with [psp > 0]
   [ask my-PSP  [set psp (psp * (100 - 5) / 100) ;;;SERVES TO EVAPORATE THE PSP AT EVERY ITERATION
                set pcolor scale-color blue psp -4 4] ] ;WE SET THE COLOR IN ACCORDANCE TO HOW MUCH PSP IS HERE. 
                
end

to control-receptors
    ifelse open = false 
      [stop]
      [ifelse ticks > open-time + 400 ;;if already open and time to close is up, close.
             [close]
             [ions-in] ]   ;;otherwise let in ions
end

;; This procedure asks ions in a cone in front of the receptor to set their heading towards
;;the receptor and set their breed to attracted ions. This releases the ions from the constraints
;;of their former breed 
to ions-in
let my-xcor [pxcor] of patch-here 
let my-ycor [pycor] of patch-here
ask nas in-cone 10 80 [
                       set breed att-ions 
                       set fired false            
                       set in-time ticks ;;set timer on to figure out when to get out
                       facexy my-xcor my-ycor ] ;;look at receptor and increase speed
end


;;These procedures make ampa receptors open and close to let ions in
to open-up
ifelse open = true 
  [stop]
  [set shape "open-receptor" set size 23 set open true set open-time ticks] 
   set binding-count binding-count + 1 ;;increase the count of receptors bound
end

to close
ifelse open = false
  [stop]
  [unbind-NT]
end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;PLOTTING PROCEDURES;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;How can I do this in the plot itself???

to make-histogram
let pen-colors [ 65 45 85 135 78]
set-plot-pen-color item (penc - 1) pen-colors
end

;;;;;;;;;;;;;;;;;SETUP PROCEDURES;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
to setup
ca

set color-world blue ;;ask patches to set their color blue. From here we will carve the synaptic gap

set binding-count 0

make-world 

set penc 1
set plot-it false

add-membrane-structures
set cleared true ;;there are no extra particles at setup, no need to clear
profiler:reset
profiler:start         ;; start profiling
reset-ticks
end

;;Make-world controls the drawing of postsynaptic structure by calling
;;to ellipse and using its outputs to determine patch location 
to make-world

set run-number 1 ;first run 

;;When bound to an NT, the postsynaptic patches will flash white as ions come into the structure
ask patches[ set pcolor color-world set psp 0 set PSP-ready false];;SETTING PSP VARIABLES
ask patches [ellipse] ;;Define an ellipse to serve as scaffolding for the synaptic structures  

;;ellipse asks patches to determine their total distance from two foci in the variable 'total'   
ask patches with [total < 162 or pycor > 30] [set pcolor black] ;;patches within the ellipse stay black
set post-synaptic patches with [pycor <= 21 and pcolor = color-world] ;;define postsynaptic structure
ask post-synaptic [set PSP-ready true] ;;ALL PATCHES ARE FIRST INITIALIZED WITH PSP-ready TO FALSE. bUT THESE PATCHES ARE GOING
;;;TO BE ABLE TO TELL THE ATT-IONS WHEN THEY HAVE GOTTEN TO THE POST-SYNAPTIC MEMBRANE

;;;define postsynaptic membrane as the blue patches abutting any patch that is black
set post-membrane post-synaptic with [any? neighbors with [pcolor = black]] 

make-particles ;;make NTs, enzymes and ions      
end

;;this procedure produces an ellipse centered on foci f1 and f2. Patches have a variable that defines their equal distance
;;from the foci (variable total). Depending on that distance, the pre and postsynaptic structures are defined
to ellipse
set f1 -60
set f2 60
set r1 round (distancexy   f1 25 )
set r2 round (distancexy  f2 25 )
set total r1 + r2
end

;;patches have a variable 'occupied' that lets them know whether they can sprout or not a vessicle or receptor
to add-membrane-structures
ask patches [set occupied false]
while [count channels < 10][make-channel] ;;make 10 receptors
end

to make-particles
make-enzymes
make-nas
set-default-shape att-ions "circle" ;ensure that att-ions remain small circles
end


;;make the ions
to make-nas
set-default-shape nas "circle"
create-nas 300
[set color orange 
       
  set r-position 2    ;;the turtles use this position to determine where they will be born
   random-position     ;;carry this variable to the random position procedure
   set size 1.4]       
end
 
to make-enzymes
 create-enzymes 7
 [set shape "enzyme"
 set color 135.9
 
 set size 15
 set partner nobody ;;enzymes will partner-up with NTs to prevent them from
 set block-time 0 ;; binding to receptors. They do so for a specific duration
 set r-position 1
 random-position
 ]
 end

;;define the position of particles in the gap 
to random-position
if r-position = 1 [setxy (60 - random 120) 19 + random 16  ]; ask enzymes to be in the gap from ycor 19 to 45
if r-position = 2 [setxy (75 - random 150)   35 - random 35]
if r-position = 3 [setxy (75 - random 150) 35 + random 3  ] ;;make sure NTs float down from the top
end

;place the channels  on the membrane

to make-channel
ask one-of post-membrane with [abs pxcor < 70] [if (occupied = false) ;;about right location on ellipse
                            [sprout 1 [set color red  
                                       set size 20 
                                       set breed channels 
                                       set partner nobody
                                       set bound-NC nobody
                                       set shape "receptor"
                                       set state 0 ;channel is unbound at the moment
                                       set open false
                                       set open-time 0 ;;receptors open for a short time
                                       set my-PSP post-synaptic in-radius 15 ;;THESE PATCHES ARE THE ONES THAT ARE ASKED TO FIRE OR SET PSP
                                       ask my-PSP [set PSP-ready true ]
                                       facexy 0 75 ] ;;have receptors face the center of the structure to orient them 
                                       ask post-membrane in-radius 10 [set occupied true]]]
                                      
end
                                                       
;;Create and "release" NTs
to inject
repeat 15 [release-Nts]
end


to release-NTs
create-NTs 1 [set breed NTs
          set r-position 3
          set color green
         set size 15
         set shape "neurotransmitter"
         set partner nobody
         set active true
         set bound false
          
         random-position
         set heading 180 fd 2]     
end
              

to add-agonists
create-NTs 10
  [set shape "agonist"
  set color yellow
  set partner nobody
  set active true
  set size 15

  set r-position 3
  random-position
  set heading 180]
  set penc 2
end

to add-antas ;antagonists look just like agonists but their color is blue
create-NTs 10
  [set shape "agonist"
  set color cyan
  set partner nobody
  set active true
  set size 15

  set r-position 3
  random-position
  set heading 180]
  set penc 3
end

to make-enzyme-antagonists
create-enzymes 10
 [set shape "anta-enz"
 set size 15
 set color cyan

 set r-position 3
 set block-time 3800 ;;so that the enzymes created will only live for the first minute of monitoring if they are inactive
 set partner nobody
 random-position
 set heading 180]
 set penc 4
end

to make-noncomp-antagonists
create-NCs 10
  [set shape "nc-agon"
  set active true
  set size 20
  set color turquoise
  set r-position 3
  set bound-time ticks
  set partner nobody
  random-position
  set heading 180]
  set penc 5
end 
@#$#@#$#@
GRAPHICS-WINDOW
587
26
1241
381
80
40
4.0
1
12
1
1
1
0
0
0
1
-80
80
-40
40
0
0
1
ticks
30.0

BUTTON
34
38
97
71
NIL
setup
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
145
39
257
72
Run Simulation
Run-Simulation
T
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
36
113
159
172
NIL
Clear-Particles
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

OUTPUT
801
396
1245
603
12

MONITOR
217
121
361
166
Approximate Time (Sec)
(3000 - ticks)/ 120
0
1
11

MONITOR
422
207
494
252
Active NTs
count NTs with [color = green]
0
1
11

MONITOR
426
286
497
331
PSP Count
binding-count
17
1
11

PLOT
28
210
364
360
PSP counts
NIL
NIL
0.0
10.0
0.0
10.0
true
false
"let pen-colors [ 65 45 85 135 78]\nset-plot-pen-color item (penc - 1) pen-colors" ""
PENS
"Run-num" 1.0 1 -2674135 true "" "if plot-it = true [plot binding-count]"

BUTTON
38
395
146
428
Agonists
add-agonists
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
189
395
383
428
Non-competitive  Antagonists
make-noncomp-antagonists
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
38
472
204
505
Competitive Antagonists
add-antas
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
235
472
378
505
Enzyme Antagonists
make-enzyme-antagonists
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

@#$#@#$#@
## WHAT IS IT?

This model is a depiction of a postsynaptic membrane and of the processes that modulate neuronal communication. A number of neurotransmitter (NT) receptors can be found on the membrane. Once a receptor is bound by an NT,  the receptor opens its ionic channel. The transient current caused by the influx of ions into the postsynaptic membrane is referred to as a postsynaptic potential  (PSP). The direction of the PSP, whether excitatory (EPSP) or inhibitory (IPSP), depends on the ionic species that enters the cell.  
A number of substances may affect the probability of an NT (green) binding and opening an ionic channel. Enzymes (pink) may inactivate the NT molecules (magenta) before they are able to bind with their receptors. Exogenous molecules such as enzyme antagonists, and NT agonists increase the probability of PSP production. On the other hand, NT antagonists, either competitive (which block the NTs binding site) or non-competitive (which permit the binding of an NT to the receptor, but prevent its opening) decrease the probability of a PSP occurring.  

## HOW IT WORKS

As NT molecules bind to receptors, the receptors change shape and "attract" ions into the postsynaptic structure. As ions enter the structure, the  patches neighboring the receptor "light up" indicating a transient current change.  
Enzymes move around the synaptic gap and, when in close proximity to an NT, they partner-up with it, ask it to change its speed and heading to their own and to change their 'active state' to false.   
Agonists and competitive antagonists behave just like NTs, with the difference that agonists ask receptors to open while antagonists simply bind and stay bound for a short period, preventing the binding of any other molecule to the receptor.   
Non-competitive antagonists allow the binding of NTs, but keep the receptors from opening.

## HOW TO USE IT

Pressing the Setup button will draw the postsynaptic membrane as well as a few enzyme molecules in the synaptic gap. There will also be a large number of ions (orange) within the synaptic gap. The specific charge of the ions does not matter, they could be Na (positive) or Chloride (negative) or something else.  
Once the membrane is in place, pressing the "Run Simulation" button will result in the release of a fixed number of NT molecules from the top of the world. These molecules will travel through the synaptic gap and bind to the receptors on the membrane. The enzyme molecules will move within the synaptic gap binding with and inactivating the NTs.  
Every time a receptor opens and allows ion influx, it counts as a single PSP. The PSP count monitor keeps track of the number of openings. A 'run' is ended when there are no more active NTs in the synaptic gap or when the clock reaches zero, whichever comes first. At this time, a bar will appear in the graph indicating the total PSPs for that run. In order to run comparisons, pressing the "Clear-Particles" button will eliminate any molecules left from the previous run without clearing the plot.  
In order to add exogenous molecules, the user can employ the appropriate buttons prior to starting the next run. 

## THINGS TO NOTICE
As the user will rapidly notice, the number of PSPs will not be the same every time the model runs, even under similar circumstances. Such variability is also found during actual synaptic transmission. However, the sheer number of NTs and receptors in real synapses dwarves by many orders of magnitude those in our model, ensuring a smaller variability between 'runs'.

## THINGS TO TRY

While the user could produce a drug "cocktail" by adding different types of exogenous substances at once, the more meaningful comparisons will be achieved by using the same number of NTs and single-substance additions a number of times (e.g. non-competitive antagonists compared to competitive antagonists in subsequent runs).

## EXTENDING THE MODEL

Biologically active molecules generally have a finite period of activity defined by their "half-life", that is, the time it takes for the total number of molecules to decrease by one half. In the present model exogenous molecules do not have a half-life and so they remain within the system until they are inactivated through interaction with other molecules.   


## CREDITS AND REFERENCES

This model is part of NeuroLab, a set of neuroscience-related simulations written by
 Luis F. Schettino
Psychology Department 
Lafayette College 
Easton, PA, USA. 
https://sites.lafayette.edu/schettil
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

agonist
true
0
Polygon -7500403 true true 105 150 150 105 195 150 105 150
Polygon -7500403 true true 105 150 105 180 120 195 180 195 195 180 195 150

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

anta-enz
true
0
Polygon -7500403 true true 105 150 150 105 195 150 105 150
Polygon -7500403 true true 135 120 165 120 150 150 135 120
Polygon -2674135 true false 133 121 167 122 149 148 134 121
Polygon -1184463 true false 160 131 153 134
Polygon -2674135 true false 132 139 169 140 150 113 132 136
Polygon -7500403 true true 162 149 162 179 178 171 173 187 167 191 160 193 155 194 151 194 149 194 149 149 162 149
Polygon -7500403 true true 136 149 136 179 120 171 125 187 131 191 138 193 143 194 147 194 149 194 149 149 136 149

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

auto-receptor
true
11
Polygon -8630108 true true 113 115 98 115 98 147 203 147 203 114 190 114 199 123 106 123 113 115

bound-agonist
true
4
Polygon -2674135 true false 105 150 105 90 150 120 195 90 195 150 105 150
Polygon -13840069 true false 105 90 195 90 150 120 105 90
Polygon -1184463 true true 105 90 105 60 120 45 165 45 180 45 195 60 195 90 150 120

bound-receptor
true
0
Polygon -7500403 true true 105 150 105 90 150 120 195 90 195 150 105 150
Polygon -13840069 true false 105 90 195 90 150 120 105 90

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

enzyme
true
0
Circle -7500403 true true 105 150 30
Circle -7500403 true true 165 150 30
Polygon -7500403 true true 188 177 213 147 213 135 206 119 192 105 174 96 154 89 150 89 150 103 198 151 174 151 189 176
Polygon -7500403 true true 112 177 87 147 87 135 94 119 108 105 126 96 146 89 150 89 150 103 102 151 126 151 111 176

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

nc-agon
true
0
Circle -7500403 true true 131 152 41
Line -7500403 true 120 149 132 177
Line -7500403 true 120 151 136 184
Line -7500403 true 120 151 137 182
Line -7500403 true 120 150 136 180
Line -7500403 true 167 180 182 152
Line -7500403 true 168 180 183 152
Line -7500403 true 166 180 181 152
Line -7500403 true 166 182 181 154
Polygon -7500403 true true 202 108 200 107
Polygon -16777216 true false 163 162 166 168 157 173 165 179 164 185 150 176 140 185 138 185 138 178 150 172 139 167 139 161 153 168 163 162

nc-agon-receptor
true
0
Polygon -2674135 true false 105 150 105 90 150 120 195 90 195 150 105 150
Circle -14835848 true false 192 100 41
Line -7500403 true 222 106 194 91
Line -7500403 true 193 150 224 133
Line -7500403 true 191 149 224 133
Line -14835848 false 193 150 224 133
Line -14835848 false 192 149 222 133
Line -7500403 true 222 106 194 91
Line -7500403 true 222 106 194 91
Line -7500403 true 222 106 194 91
Line -14835848 false 222 106 194 91
Line -14835848 false 222 107 194 92
Polygon -7500403 true true 202 108 200 107
Polygon -16777216 true false 201 108 207 105 212 114 218 106 224 107 215 121 224 131 224 133 217 133 211 121 206 132 200 132 207 118 201 108

nc-agon-receptor-bound-ant
true
0
Polygon -2674135 true false 105 150 105 90 150 120 195 90 195 150 105 150
Circle -14835848 true false 192 100 41
Line -7500403 true 222 106 194 91
Line -7500403 true 193 150 224 133
Line -7500403 true 191 149 224 133
Line -14835848 false 193 150 224 133
Line -14835848 false 192 149 222 133
Line -7500403 true 222 106 194 91
Line -7500403 true 222 106 194 91
Line -7500403 true 222 106 194 91
Line -14835848 false 222 106 194 91
Line -14835848 false 222 107 194 92
Polygon -7500403 true true 202 108 200 107
Polygon -16777216 true false 201 108 207 105 212 114 218 106 224 107 215 121 224 131 224 133 217 133 211 121 206 132 200 132 207 118 201 108
Polygon -7500403 true true 150 120 105 90 105 60 120 45 180 45 195 60 195 90 150 120 105 90

nc-agon-receptor-bound-nt
true
0
Polygon -2674135 true false 105 150 105 90 150 120 195 90 195 150 105 150
Circle -14835848 true false 192 100 41
Line -7500403 true 222 106 194 91
Line -7500403 true 193 150 224 133
Line -7500403 true 191 149 224 133
Line -14835848 false 193 150 224 133
Line -14835848 false 192 149 222 133
Line -7500403 true 222 106 194 91
Line -7500403 true 222 106 194 91
Line -7500403 true 222 106 194 91
Line -14835848 false 222 106 194 91
Line -14835848 false 222 107 194 92
Polygon -7500403 true true 202 108 200 107
Polygon -16777216 true false 201 108 207 105 212 114 218 106 224 107 215 121 224 131 224 133 217 133 211 121 206 132 200 132 207 118 201 108
Polygon -7500403 true true 150 120 105 90 120 90 180 90 195 90 150 120 105 90

neurotransmitter
true
0
Polygon -7500403 true true 105 150 150 105 195 150 105 150

open-receptor
true
0
Polygon -2674135 true false 158 184 158 136 158 132 160 127 163 124 168 124 171 124 175 126 176 132 176 138 176 146 175 154 172 158 169 166 165 174 162 180 158 184
Polygon -7500403 true true 157 131 177 170
Polygon -2674135 true false 143 184 143 136 143 132 141 127 138 124 133 124 130 124 126 126 125 132 125 138 125 146 126 154 129 158 132 166 136 174 139 180 143 184

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

receptor
true
1
Polygon -2674135 true true 105 150 105 90 150 120 195 90 195 150 105 150
Polygon -7500403 true false 202 108 200 107

sheep
false
15
Circle -1 true true 203 65 88
Circle -1 true true 70 65 162
Circle -1 true true 150 105 120
Polygon -7500403 true false 218 120 240 165 255 165 278 120
Circle -7500403 true false 214 72 67
Rectangle -1 true true 164 223 179 298
Polygon -1 true true 45 285 30 285 30 240 15 195 45 210
Circle -1 true true 3 83 150
Rectangle -1 true true 65 221 80 296
Polygon -1 true true 195 285 210 285 210 240 240 210 195 210
Polygon -7500403 true false 276 85 285 105 302 99 294 83
Polygon -7500403 true false 219 85 210 105 193 99 201 83

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

wolf
false
0
Polygon -16777216 true false 253 133 245 131 245 133
Polygon -7500403 true true 2 194 13 197 30 191 38 193 38 205 20 226 20 257 27 265 38 266 40 260 31 253 31 230 60 206 68 198 75 209 66 228 65 243 82 261 84 268 100 267 103 261 77 239 79 231 100 207 98 196 119 201 143 202 160 195 166 210 172 213 173 238 167 251 160 248 154 265 169 264 178 247 186 240 198 260 200 271 217 271 219 262 207 258 195 230 192 198 210 184 227 164 242 144 259 145 284 151 277 141 293 140 299 134 297 127 273 119 270 105
Polygon -7500403 true true -1 195 14 180 36 166 40 153 53 140 82 131 134 133 159 126 188 115 227 108 236 102 238 98 268 86 269 92 281 87 269 103 269 113

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270

@#$#@#$#@
NetLogo 5.0.4
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 1.0 0.0
0.0 1 1.0 0.0
0.2 0 1.0 0.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180

@#$#@#$#@
0
@#$#@#$#@
