patches-own [attract1 attract2  repulse attract3] ;substances that attract or repel the axons
breed[axons axon];axons

breed [targets target]
breed [synapses synapse]
globals [walls septum baseline] ;;fixed structures 

to setup
 ca
 
 set-baseline
  
   ask patches [set pcolor 4 + random 2 ]
   do-walls
  create-agents
  ask patches [ set attract1 0 set attract2 0 set attract3 0  set repulse 0]
   make-septum
  reset-ticks
end
  
to create-agents
  
  crt 2 ;;create two target turtles for the axons to move to
    [set breed targets
     set shape "circle"
     set size 6]
     ask target 0 [setxy 30 35 set color green]
     ask target 1 [setxy -30 35 set color red]
  
  crt 20 ;;create 20 axon terminals and place them randomly around the midline
  [ 
    set breed axons
   ifelse who mod 2 = 0 [set color red] [set color green]
   set shape "terminal"
   
   set size 6  
   setxy  3 - random 7 -70 pd
   set heading 0 fd 30 ;;move terminals a bit forward to create a fiber tract
   
   ]
       
  
end

to set-baseline
  ask patches [if pycor = -70 and abs pxcor < 50  [set pcolor yellow]] 
  ask patches [if pycor = -69 and abs pxcor < 40  [set pcolor yellow]] 
  ask patches [if pycor = -68 and abs pxcor < 35  [set pcolor yellow]]
  ask patches [if pycor = -77 and abs pxcor < 30  [set pcolor yellow]]  
  set baseline patches with [pcolor = yellow]
end

;;Create two side walls that will repel the axons and a frontal structure (septum) that will attract them
to do-walls
ask patches [
  
     if (abs pxcor < 34 and abs pxcor > 15) 
      [
         if  (pycor > -55 and pycor < 4) or (pycor > -55 and pycor < 0)
             [set pcolor 34]
           ]]


set walls patches with [pcolor = 34]

;;then the other targets cause the decussation
end


to make-septum
ask patches [if pxcor = 0 and pycor > -7 and pycor < 30 [set pcolor magenta]  ]
ask patches [if abs pxcor  < 1 and pycor >  3 and pycor < 30 [set pcolor magenta]  ]
ask patches [if abs pxcor  < 2 and pycor >  8 and pycor < 30 [set pcolor magenta]  ]
ask patches [if abs pxcor  < 3 and pycor >  15 and pycor < 30 [set pcolor magenta]  ]
set septum patches with [pcolor = magenta]
ask septum [set pcolor 35]
end

to go
if not any? axons  [stop] ;if the axons reach the targets they turn into synapses and we stop the sim

ask axons
  [
     
   if repulse > 0.5 [turn-away fd 1] ;;stay away from walls
   ;; all axons move towards septum to begin with
   if attract3 > 0.01 and attract3 < 30                
     [turn-toward-attract3
     ; rt random-float 25 - random-float 25 + -2
      fd 1]
      
   ifelse color = green
     [
       if attract2 > 150 [set breed synapses set shape "synapse"] ;;if next to target, turn to synapse
       if attract2 > 0.02                 ;; begin moving towards target when you feel enough attractant 
       [turn-toward-attract2
        
        fd 1]]
     [ ;;red axons
       if attract1 > 150 [set breed synapses set shape "synapse"]
       if attract1 > 0.02               
       [turn-toward-attract1
      
        fd 1]]
                ]
    
  control-release ;;control release and diffusion of substance
  
  tick ;;keep tab of iterations
end
   
   
to control-release
    ;;ask targets and structures to release their respective substance
  
  ask patches [ ;;prevent substances from touching end of world (to prevent stray axons)
                if pxcor > max-pxcor - 2 [set attract1 0 set attract2 0]
                if abs pycor > max-pycor - 2 [set attract1 0 set attract2 0]
                ]
  
  ;for some reason the first factor that is released becomes much stronger than the second factor
  if Factor_1 [ask target 1 [set attract1 attract1 + 400 ] ] 
  if Factor_2 [ask target 0 [set attract2 attract2 + 400 ] ]
  
  if Factor_3 [ask septum   [set attract3 attract3 + 50] ] 
  ;if Factor_4 [ask walls [set repel 10 - attract3]  ];modulate repel with attract to force axons up
  
  if Factor_4 [ask baseline [set repulse repulse + 5]]
    
  ;;diffuse substances to neighboring patches if switches are on  
 
  if Factor_1 [diffuse attract1 1] 
  if Factor_2 [diffuse attract2 1]
  if Factor_3 [diffuse attract3 1]
  ;if Factor_4 [diffuse repel 0.01]
  if Factor_4 [diffuse repulse 1]
  
  ;;evaporate substances slowly                  
  ask patches[
  ; set attract1 attract1 * 0.995
  ;set attract2 attract2 * 0.995 
  set attract3 attract3 * 0.95]                
end

;;Modified from the SLIME simulation in the Models Library
;;turn-away is just like turn-toward but turns the turtle 180 degrees in the opposite direction
to turn-away  ;; turtle procedure
  ;; examine the patch ahead of you and two nearby patches;
  ;; turn in the direction of greatest chemical
  let ahead [repulse] of patch-ahead 1
  let myright [repulse] of patch-right-and-ahead 33 1
  let myleft [repulse] of patch-left-and-ahead 33 1
  ifelse (myright <= ahead) and (myright <= myleft)
  [ rt 33 ]
  [ ifelse myleft <= ahead
    [ lt 33 ]
    [stop ]
  ]
    
end


;;from SLIME simulation in the Models library. 
to turn-toward-attract3  ;; turtle procedure
  ;; examine the patch ahead of you and two nearby patches;
  ;; turn in the direction of greatest chemical
 
  
    let ahead [attract3] of patch-ahead 1
let myright [attract3] of patch-right-and-ahead 33 1
let myleft [attract3] of patch-left-and-ahead 33 1
ifelse (myright >= ahead) and (myright >= myleft)
  [ rt 33 ]
[ if myleft >= ahead
    [ lt 33 ] ]
    ;; default: don't turn
end 

to turn-toward-attract1  ;; turtle procedure
  ;; examine the patch ahead of you and two nearby patches;
  ;; turn in the direction of greatest chemical
  uphill attract1
  
 
     
    
end
to turn-toward-attract2  ;; turtle procedure
  ;; examine the patch ahead of you and two nearby patches;
  ;; turn in the direction of greatest chemical
  
   uphill attract2
     
end

@#$#@#$#@
GRAPHICS-WINDOW
427
24
1009
721
60
70
4.73
1
10
1
1
1
0
0
0
1
-60
60
-70
70
0
0
0
ticks
30.0

BUTTON
53
30
116
63
setup
setup
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
169
29
233
62
go
go
T
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

SWITCH
21
180
163
213
Factor_3
Factor_3
0
1
-1000

SWITCH
21
147
163
180
Factor_2
Factor_2
0
1
-1000

SWITCH
21
213
163
246
Factor_4
Factor_4
0
1
-1000

BUTTON
197
149
323
182
Show Factor_2
ask patches [\nset pcolor scale-color green attract2 0.1 250]
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
197
116
323
149
Show Factor_1
ask patches [\nset pcolor scale-color red attract1 0.1 250]
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
197
182
323
215
Show Factor_3
ask patches[\nset pcolor scale-color yellow attract3 5 400]
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
196
215
323
248
Show Factor_4
ask patches[\nset pcolor scale-color blue repulse 0.1 100]
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

SWITCH
21
113
163
146
Factor_1
Factor_1
0
1
-1000

MONITOR
258
306
325
351
Iterations
ticks
0
1
11

@#$#@#$#@
## WHAT IS IT?

The Axonal Guidance simulation exemplifies the process through which neuronal axons find their way to their intended targets during brain development. The simulation presents the possibility to turn on and off five different 'substances' or factors and to observe the consequences of those choices on the final state of development.
The factors in the simulation are released by the structures in the world as 'guidance cues' for the axonal growth cones (green or red) and either attract or repel them, leading them to their respective color targets.

## HOW IT WORKS

As part of NeuroLab, this simulation was designed to have students determine the function of each of the substances by a careful process of hypothesis testing. Typically, the user will turn off no more than one factor at a time and observe the results as well as the sphere of action of each factor through the use of the 'Show Factor' buttons.
Once a hypothesis is developed, the user may decide to turn off two or three factors off to test it. 


## HOW TO USE IT

Pressing the 'Setup' button creates a diagrammatic representation of a set of axonal growth cones (lower margin) at the midline, with two targets at either right or left. Pressing the 'Go' button causes the growth cones to follow chemical cues released by the neighboring structures. Such guidance cues lead them towards their respective targets (labeled by color). 

Turning on and off the Factor switches will eliminate the release of that specific substance, leading to abnormal development. The goal of the user is to determine what each one of the factors does.

## THINGS TO NOTICE

In some cases, turning off a factor may produce results that are almost identical to those when the factor is on. It may be necessary to run the simulation a couple of times under the same conditions to notice that there is indeed a difference that provides hints as to what that factor does. 

## RELATED MODELS

NeuroLab includes a Cortical Development simulation that also employs chemical cues to guide brain development.

## CREDITS AND REFERENCES

A classic article on this topic is Tessier-Lavigne & Goodman (1996) The molecular biology of axon guidance. Science 274, 1123-1133.

This model is part of NeuroLab, a set of neuroscience-related simulations in NetLogo written by
Luis F. Schettino
Psychology Department 
Lafayette College 
Easton, PA, USA. 
https://sites.lafayette.edu/schettil
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

synapse
true
0
Polygon -7500403 true true 150 0 45 195 75 195 150 75 225 195 255 195 150 0

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

terminal
true
0
Polygon -7500403 true true 120 300 45 75 75 105 90 135 75 75 105 120 120 75 135 120 150 75 165 120 180 75 195 120 210 75 225 135 225 105 240 75 240 120 165 300 120 300

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270

@#$#@#$#@
NetLogo 5.0.4
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 0.0 1.0
0.0 1 1.0 0.0
0.2 0 0.0 1.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180

@#$#@#$#@
0
@#$#@#$#@
