

breed [pyramidals pyramidal]
breed [tips tip]
breed [glias glia]
breed [stems stem]
breed [blasts blast]
breed [stellates stellate]
breed [pias pia]


patches-own [layer scent  VZjuice  level my-color] ;separate factors per layer

globals [ layerV layerIV layerIII  pia VZ  margin VCount IVCount IIICount  counter]

blasts-own [fate CR mark]



to develop
ifelse IIICount > 125
[clean-up stop ]
[go
if ticks > 80 [reproduce]]
end



to go
ask tips [grow]
swell
ask blasts[ 
           migrate
           differentiate ]

ask VZ [set VZjuice 0.5]
diffuse-factors

tick
end


to clean-up
ask tips[die]
ask patches [set pcolor my-color]
ask glias[die]
ask blasts[die]
ask stems[die]
ask pias[die]
release-factors
end

;ask each layer to set their 'level' to a prespecified amount
to release-factors
  
ask patches with [pycor = -15] [set level 60];layer V
ask patches with [pycor =  15] [set level 60];layer IV
ask patches with [pycor =  45] [set level 60];layer III
  

repeat 35 [diffuse level 1]
repeat 15 [diffuse scent 1]
end


to show-factor
ask patches [set pcolor black]

if factor = "Layer V" and LayerV-factor = true
[ask LayerV [set pcolor scale-color green level 0.1 5.5]]

if factor = "Layer III"and LayerIII-factor = true
[ask LayerIII [set pcolor scale-color orange level 0.1 3.5]]

if factor = "Layer IV"and LayerIV-factor = true
[ask LayerIV [set pcolor scale-color yellow level 0.1 3.5]]

if factor = "Glia"
[ask patches [set pcolor scale-color pink scent 0.7 5]]
end


to switch-background
  set counter counter + 1
  ifelse counter mod 2 = 1
[ask patches [set pcolor black]]
[ask patches [set pcolor my-color]]
end
;;/////////////////////////////////////DEVELOPING FUNCTIONS////////////////////////////

to reproduce 
  
  if ticks mod 30 = 0[
             ask n-of 30 stems [
  
                        if shape = "blast"[
                                          hatch 1 [
                                                    set breed blasts  
                                                  
                                                    set size 7 
                                                    set color green 
                                                    set shape "blast" 
                                                    set heading 0
                                                    set mark false
           
                                                    ifelse VCount < 125
                                                         [set fate 5]
                                                         [ifelse IVCount < 125
                                                                 [set fate 4]
                                                                 [set fate 3]]
            
                                                    ]]
                        
                         if shape = "lab-blast"[
                                            hatch 1 [
                                                     set breed blasts  
                                                    
                                                     set size 7 
                                                     set color green 
                                                     set shape "lab-blast" 
                                                     set heading 0
                                                     
                                                     ifelse VCount < 125
                                                         [set fate 5]
                                                         [ifelse IVCount < 125
                                                                 [set fate 4]
                                                                 [set fate 3]]
    
                                                       
    
                                                      ]]]]
                                           
            
end

to swell
  
set margin [ycor] of one-of pias  
ask pias[
ifelse margin = max-pycor 
  [stop]
  [
  if any? blasts with [CR = true and pycor = margin]
  [fd 1 ]]]


ask patches [ifelse pycor  < margin and pycor >= -40 and pcolor != pink [set pcolor my-color][stop] ] ;respect the glia traces
ask patches [ifelse pycor  < -40 and pcolor != pink [set pcolor my-color][stop] ] ;respect the glia traces


end

to grow

ifelse count tips > 3
 
      [ask n-of 3 tips 
           [if [pcolor] of patch-ahead 1 != black 
                 [ fd 0.9
                   ask patch-here [set scent 5]
                   ask patch-here [set pcolor pink]]]]
     [stop] 
                                     

 
end

;;////////////////////MIGRATING PROCEDURES//////////////////////////////////


to migrate
  
   if ycor >= 79 [die];if you reached the top of the world, die
  
  if CR != true
  [follow-scent];find your radial glia fiber
  
  ifelse count blasts with [CR = true] > 4
  [ask n-of 4 blasts with [CR = true] [ fd 0.045] if pycor > margin [die]] ;give an advantage to CRs so they don't lag behind
  [ask  blasts with [CR = true] [ fd 0.045] if pycor > margin [die]]
  
 
   let total-blasts  count blasts with [CR != true]
  ask n-of (total-blasts / 25) blasts with [CR != true];to prevent all blasts from moving in unison
   [ fd 0.15]  

  
end



;This procedure is now using patch color rather than scent. The scent was left in the simulation
;to show that glias also use a factor to guide blasts towards them
to follow-scent  

;;use cone primitive to find the trace and follow it
ifelse [pcolor] of patch-here != pink 
[
  let view patches in-cone 5 60 with [pcolor = pink]
  let target one-of view
  if target = nobody [die]
  let X [pxcor] of target 
  let Y [pycor] of target
  facexy X Y 
  fd 1 ]
[set heading 0  grab-on stop]
   
end


to diffuse-factors
diffuse VZjuice 0.5
diffuse scent 0.5

end


;;//////////////////////DIFFERENTIATION PROCEDURES////////////////////////////


to grab-on
  ifelse CR = true
  [stop]
  [ ifelse mark = false ;if you are not labeled
    [ifelse shape = "shimmy" ;but your shape is already shimmy
      [stop]  ;don't do anything
      [ set shape "shimmy" ]] ;otherwise, take shape shimmy
    
    [ifelse shape = "lab-shimmy" ;but if you are labeled
       [stop]
       [ set shape "lab-shimmy" ]];make sure to have shape lab-shimmy
    
    
    set size 12]
 
   
end

;CRs are actually blasts that have changed shape and color


to differentiate
  
if count blasts with [CR = true ]< 35 and ticks < 300

[if [VZjuice] of patch-here > 0.1  [set CR true set fate 9 set shape "Cajal-Retzius" set size 6 set color yellow set heading 0]]


if [layer] of patch-here = 3 and fate = 3 [ 
                                                 ifelse  shape = "shimmy" [set shape "pyramidal"][set shape "lab-pyr"]
                                                 
                                                 set IIICount IIICount + 1  
                                                 set color blue
                                                 set heading 0 
                                                 set size 6 
                                                 ask patches in-radius 5 [set layer 0] 
                                                 stamp die ]
if [layer] of patch-here = 4 and fate = 4 [
                                                ifelse shape = "shimmy" [set shape "stellate"][set shape "lab-stellate"]
                                               
                                                set IVCount IVCount + 1  
                                                set color violet 
                                                set heading 0 
                                                set size 5 
                                                ask patches in-radius 5 [set layer 0] 
                                                stamp die ]
if [layer] of patch-here = 5 and fate = 5  [
                                                 ifelse shape = "shimmy" [set shape "pyramidal"][set shape "lab-pyr"]
                                                 
                                                set VCount VCount + 1 
                                                set color red 
                                                set heading 0 
                                                set size 6 
                                                ask patches in-radius 5 [set layer 0] 
                                                stamp die ]

end

;;///////////////////////IMPLANT PROCEDURES///////////////////////////////////

to implant 
  
  ifelse Implanted-Type = "Young Precursor"
  
  [ ask n-of 30  stems[
                         hatch 1 [
                                    set breed blasts
                                 
                                    set fate 5 
                                    set size 12 
                                    set color green 
                                    set mark true
                                    set shape "lab-shimmy" 
                                    set heading 0]
                                         ]
    ask layerV [set layer 5]]
  
  [ask n-of 10 stems[set shape "lab-blast"]]
  
  
end

;;////////////////////////////////////SETUP PROCEDURES////////////////////////////////
to setup
ca
ask patches [set level 0 set layer 0 set my-color 0];boolean to release factors or not
create-cells
setup-regions
set margin 0
set VCount 0
set IVCount 0
set IIICount 0

check-factor-switches
set counter 0
reset-ticks
end

to setup-regions
set VZ patches with [pycor >= -50 and pycor <= -40] ;;define ventricular zone 
ask VZ[set VZjuice 0];ask VZ to set its factor to 0

ask patches with [pycor < -40] [set my-color 39.5 - (random 6 * 0.5) set pcolor my-color]
ask patches with [pycor >= -40] [set my-color 79.5 - (random 4 * 0.5) set pcolor black]
ask patches with [pycor = -40 and pxcor mod 7 = 0][sprout 1[ set breed pias set color brown set shape "flat" set heading 0 set size 9]]



set layerV patches with [pycor > -25 and pycor < -5] ask layerV [set layer 5]
set layerIV patches with [pycor > 5 and pycor < 25] ask layerIV [set layer 4]
set layerIII patches with [pycor > 35 and pycor < 55] ask layerIII [set layer 3]


end


to check-factor-switches
  if LayerV-factor = false
    [ask layerV [set layer 9] set Vcount 125]
    
  if LayerIV-factor = false
    [ask layerIV [set layer 9] set IVcount 125]
    
  if LayerIII-factor = false
    [ask layerIII [set layer 9] set IIIcount 125]
  
  
  
end


to create-cells 
make-stems
make-glias
end


to make-glias
  
  ask patches with [pycor = -75 + random 3 ]
    [
  
  sprout 1[

  set breed glias
  set shape "glia" 
  set heading 0 
  set color pink 
  set size 7
 ask other glias in-radius 1.5 [die];trim back clusters
  ]]


 
    
    
ask glias [hatch 1[
          set breed tips 
          set shape "lamelipodio" 
          set size 9 
          set heading 0 
          fd 3
          
          ]
]

end





to make-stems
ask patches with [pycor = -70 + random 6 ]
[sprout 1[
  set breed stems
  set shape "blast"
  set heading 0 
  set color magenta 
  set size 7
  if any? other stems in-radius 4 [die]
]]

end
@#$#@#$#@
GRAPHICS-WINDOW
435
51
1260
548
140
80
2.9004
1
10
1
1
1
0
0
0
1
-140
140
-80
80
0
0
1
ticks
15.0

BUTTON
49
41
112
74
NIL
setup
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
179
47
256
80
NIL
Develop
T
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

CHOOSER
38
157
182
202
Implanted-Type
Implanted-Type
"Young Precursor" "Young Progenitor" "Old Progenitor"
0

BUTTON
221
163
292
196
NIL
implant
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

CHOOSER
40
283
178
328
Factor
Factor
"Glia" "Layer V" "Layer IV" "Layer III"
2

BUTTON
213
294
311
327
NIL
show-factor
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

SWITCH
50
392
182
425
LayerV-factor
LayerV-factor
0
1
-1000

SWITCH
47
452
183
485
LayerIV-factor
LayerIV-factor
0
1
-1000

SWITCH
45
508
184
541
LayerIII-factor
LayerIII-factor
0
1
-1000

TEXTBOX
222
406
372
448
Select factors to eliminate\nbefore \npressing SETUP
11
0.0
1

BUTTON
75
103
225
136
NIL
switch-background
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

@#$#@#$#@
## WHAT IS IT?
This model is a simulation of cortical development. It explores the mechanisms through wich cell-to-cell interactions give rise to a layered structure without the need for genetically determined organization. 
Cellular progenitors (magenta) within the ventricular zone (VZ), represented by a band of light brown colors at the bottom of the world give rise to cellular precursors (green) which seek a set of chemical markers in order to differentiate into the appropriate cellular types of the cortex. The direction of their migration is facilitated by following the fibers of radial glia cells (pink) that grow perpendicular to the cortical margin. 
This simulation only shows three layers of the cortex (layers III, IV and V).


## HOW IT WORKS
 As the neural progenitors reach different spatial levels in the system, they differentiate into distinct cellular types such as pyramidal cells (red or blue) or stellate cells (purple). In order to recognize the type of cell they need to turn into, they rely on the chemical context of each layer.

## HOW TO USE IT

Pressing the Setup button will show a group of cells close to the bottom of the NetLogo world. This represents the ventricular zone neighboring the neural tube in the embryo. The Black area represents unoccupied space. As the tissue grows, small yellow cells (Cajal-Retzius cells) begin to occupy the space and glial cell processes attach to the dorsal layer of the tissue. The small cells will produce substances that induce the migrating neuronal progenitors to differentiate into different cellular types. Once the tissue has filled the available space, the ventricular zone cells dissapear, leaving the mature cortical tissue in place.
Turning OFF specific factors before pressing Setup will result in the lack of that factor during development, with a consequent loss of a cortical layer. 
Pressing the Implant button will result in the labeling of a set of cells in order to find out where they will end up after development. This simulates a common laboratory technique employed to unravel the timing of when neurons acquire their cellular fates.


## THINGS TO NOTICE

Notice that the development of the cortical layers is a somewhat haphazard process. Cells may neighbor one another very closely. However, following layer production, the cortex still undergoes a round of cell death before the final structure is established. Biological processes often work this way.


## THINGS TO TRY

Pressing show-factor button will allow you to see the concentration of factors at the different locations in the model. Toggle between differentiating factors with the factors chooser switch.  


## CREDITS AND REFERENCES

Based on McConnell, S.K.(1995) Constructing the Cerebral Cortex: neurogenesis and fate determination, Neuron 15, 761-768, and Wu et al., (2005) Pyramidal neurons of upper cortical layers generated by NEX-positive progenitor cells in the subventricular zone, PNAS 102, 17172-17177, as reviewed in Squire et al., (2008) Fundamental Neuroscience, 3rd Edition. Academic Press.

This model is part of NeuroLab, a set of neuroscience-related simulations in NetLogo written by
 Luis F. Schettino
Psychology Department 
Lafayette College 
Easton, PA, USA. 
https://sites.lafayette.edu/schettil 
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

blast
true
0
Circle -7500403 true true 60 60 180
Circle -7500403 true true 60 45 180
Circle -7500403 true true 60 30 180
Circle -7500403 true true 60 15 180
Circle -7500403 true true 60 90 180
Circle -7500403 true true 75 135 150
Circle -7500403 true true 75 0 150
Circle -16777216 true false 105 105 90

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

cajal-retzius
true
0
Polygon -7500403 true true 15 90 0 105 0 120 30 105 45 120 75 135 45 165 15 150 0 165 15 165 45 180 60 195 90 225 135 240 195 240 225 210 255 180 270 165 300 180 285 150 255 150 285 105 285 90 270 105 255 120 240 120 225 90 195 60 165 60 120 60 90 75 60 90
Circle -16777216 true false 120 120 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flat
false
0
Rectangle -7500403 true true 30 120 285 180

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

glia
true
0
Polygon -7500403 true true 15 105 30 90 30 75 45 60 60 45 75 45 90 30 105 30 120 30 120 15 135 15 165 30 180 30 195 45 210 45 225 30 240 45 255 60 255 75 255 90 270 105 285 120 285 135 285 150 270 180 285 195 255 225 240 255 225 255 210 270 195 285 180 285 150 270 135 270 105 285 75 255 60 255 60 225 45 225 30 210 15 195 15 180 30 150 15 135 15 105
Circle -16777216 true false 63 63 175

granule
true
0
Polygon -7500403 true true 15 105 45 90 75 105 75 45 120 75 120 30 150 60 195 30 195 75 240 45 225 105 270 90 255 120 240 135 270 180 225 165 255 210 210 210 210 255 180 240 165 270 135 240 90 255 90 225 45 225 60 180 15 165 30 150 15 135 30 135 45 120
Circle -16777216 true false 86 86 127

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

lab-blast
true
0
Circle -7500403 true true 60 60 180
Circle -7500403 true true 60 45 180
Circle -7500403 true true 60 30 180
Circle -7500403 true true 60 15 180
Circle -7500403 true true 60 90 180
Circle -7500403 true true 75 135 150
Circle -7500403 true true 75 0 150
Circle -1184463 true false 105 105 90
Circle -16777216 true false 116 116 67

lab-pyr
false
0
Polygon -7500403 true true 150 30 45 255 255 255
Circle -1184463 true false 105 135 90
Circle -16777216 true false 120 150 60

lab-shimmy
false
0
Circle -7500403 true true 88 103 124
Circle -7500403 true true 88 73 124
Circle -7500403 true true 88 88 124
Circle -1184463 true false 105 105 90
Polygon -7500403 true true 150 225 135 240 135 255 135 270 120 255 120 240 135 225
Polygon -7500403 true true 180 285 180 270 165 255 165 285
Polygon -7500403 true true 120 15 120 30 135 45 135 15
Polygon -7500403 true true 150 75 165 60 165 45 165 30 180 45 180 60 165 75
Polygon -2064490 true false 165 285 135 285 135 240 150 225 165 225 165 285
Polygon -2064490 true false 135 15 165 15 165 60 150 75 135 75 135 15
Circle -16777216 true false 120 120 60

lab-stellate
true
0
Polygon -7500403 true true 15 105 45 90 75 105 75 45 120 75 120 30 150 60 195 30 195 75 240 45 225 105 270 90 255 120 240 135 270 180 225 165 255 210 210 210 210 255 180 240 165 270 135 240 90 255 90 225 45 225 60 180 15 165 30 150 15 135 30 135 45 120
Circle -1184463 true false 86 86 127
Circle -16777216 true false 103 103 95

lamelipodio
true
0
Rectangle -7500403 true true 135 150 165 240
Polygon -7500403 true true 135 150 90 105 105 105 120 120 105 75 120 60 135 120 135 60 150 45 150 60 150 90 165 60 180 75 150 105 195 90 195 105 165 120 195 120 210 135 180 135 165 150

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

pyramidal
false
0
Polygon -7500403 true true 150 30 45 255 255 255
Circle -16777216 true false 105 135 90

sheep
false
15
Circle -1 true true 203 65 88
Circle -1 true true 70 65 162
Circle -1 true true 150 105 120
Polygon -7500403 true false 218 120 240 165 255 165 278 120
Circle -7500403 true false 214 72 67
Rectangle -1 true true 164 223 179 298
Polygon -1 true true 45 285 30 285 30 240 15 195 45 210
Circle -1 true true 3 83 150
Rectangle -1 true true 65 221 80 296
Polygon -1 true true 195 285 210 285 210 240 240 210 195 210
Polygon -7500403 true false 276 85 285 105 302 99 294 83
Polygon -7500403 true false 219 85 210 105 193 99 201 83

shimmy
false
0
Circle -7500403 true true 88 103 124
Circle -7500403 true true 88 73 124
Circle -7500403 true true 88 88 124
Circle -16777216 true false 120 120 60
Polygon -7500403 true true 150 225 135 240 135 255 135 270 120 255 120 240 135 225
Polygon -7500403 true true 180 285 180 270 165 255 165 285
Polygon -7500403 true true 120 15 120 30 135 45 135 15
Polygon -7500403 true true 150 75 165 60 165 45 165 30 180 45 180 60 165 75
Polygon -2064490 true false 165 285 135 285 135 240 150 225 165 225 165 285
Polygon -2064490 true false 135 15 165 15 165 60 150 75 135 75 135 15

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

stellate
true
0
Polygon -7500403 true true 15 105 45 90 45 60 75 45 90 15 120 30 165 15 195 30 210 30 240 45 240 60 270 90 255 120 270 150 270 180 255 210 255 240 225 255 195 285 165 285 135 270 105 285 75 255 45 240 30 210 15 180 15 150 30 120 15 105 30 120 45 120
Circle -16777216 true false 86 86 127

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

wolf
false
0
Polygon -16777216 true false 253 133 245 131 245 133
Polygon -7500403 true true 2 194 13 197 30 191 38 193 38 205 20 226 20 257 27 265 38 266 40 260 31 253 31 230 60 206 68 198 75 209 66 228 65 243 82 261 84 268 100 267 103 261 77 239 79 231 100 207 98 196 119 201 143 202 160 195 166 210 172 213 173 238 167 251 160 248 154 265 169 264 178 247 186 240 198 260 200 271 217 271 219 262 207 258 195 230 192 198 210 184 227 164 242 144 259 145 284 151 277 141 293 140 299 134 297 127 273 119 270 105
Polygon -7500403 true true -1 195 14 180 36 166 40 153 53 140 82 131 134 133 159 126 188 115 227 108 236 102 238 98 268 86 269 92 281 87 269 103 269 113

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270

@#$#@#$#@
NetLogo 5.0.4
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 1.0 0.0
0.0 1 1.0 0.0
0.2 0 1.0 0.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180

@#$#@#$#@
0
@#$#@#$#@
