
;CALCULATE THE PROPER FIRING POWER OF THE CELLS?/

;draw the AP a bit better


globals [perc some charge potential smoothed] 
breed [inputs input];the cells that send their input to the central neuron
breed [cells cell]; the central neuron only

inputs-own [action-time strength active value]
cells-own [depolarized]

to setup
ca
create-inputs number-of-inputs ;create input cells
ask inputs [setxy 0 -5]
set smoothed 0 ;this variable is used to smooth out the final signal to be plotted
ask inputs [
set label 0 
set value 1;input cells have a value 1 for exc, 0 for inh
set strength 0
set action-time 0
set active false
find-place
ennumerate
settype
]
Make-cell
ask cells [set depolarized false set potential charge setxy 0 -5]
create-network
ask links [set color 117]
reset-ticks
end


to go
;if ticks mod 10 = 0[
  ask inputs [
        monitor-fire
        set-strengths]
  
  fire-tonics
  ask cells [calculate-potential]
  set smoothed 0.9 * smoothed + (1 - 0.9) * potential ;smooth charge signal
  do-plot;]
tick
end

;;//////// Blue Cell procedures /////

;;if the cell's potential is higher than - 30mV it's set to depolarized and its color gets lighter
;;otherwise we bring down the internal charge by attenuating it
to calculate-potential
ifelse potential > -30 
  [ask cells [set depolarized true set color 49 AP]]
  [attenuate]
end

;;if the cell's potential deviates from its resting potential of -70mV, the attenuate procedure brings
;;it back slowly to it
to attenuate
ifelse potential < -70
 [set potential (potential + 0.05)]
 [set potential (potential - 0.05)] 
end

;;but if the cell is in a depolarized state (has reached threshold of -30 mV, we produce an action 
;;potential (AP)

to AP
ifelse depolarized = true
  [ifelse potential < 40
    [set potential (potential + 5)] ;;action potential
    [set depolarized false set potential -80 set color cyan]];;go back down with a refractory period starting at -80
   [stop] 
end


;;////// Input Procedures  ///////

;;if the corresponding button is pressed, the input cell is set to active and its active time is 
;;initiated

to fire [i]
ask inputs [if label = i 
  [set active true
  set action-time ticks
    ifelse value = 1 ;if excitatory
      [set color 68] ; turn light green
      [set color 18]
      ]]
end

;;at every iteration, check if input cells are in active state. If so, check if their charge
;;time is up. If it is, send them back to their baseline, otherwise, modulate their state
to monitor-fire
if active = true 
 [ifelse ticks < action-time + 10
    [modulate-charge]
    [back-to-baseline] ]
end
    
;;return input cells to their resting state    
to back-to-baseline
ifelse value = 1;;if excitatory, reset to green, otherwise, to red
  [set color green set active false]
  [set color red set active false] 
end    
  
;;if the cell is in active state, at every iteration cause the blue cell's potential to
;;increase by the input cell's connection strength as determined by its slider
to modulate-charge
ifelse value = 1
  [set potential potential + (strength * 1.2)]
  [set potential potential - (strength * 1)] 
end


;;/// Tonic Input procedures///

to fire-tonics
 if ticks mod (cycle-1 * 50) = 0 ;ask tonics to fire every 30 ticks 
    [fire-Tonic-1]
 if ticks mod (cycle-2 * 50)= 0 ;ask tonics to fire every 30 ticks 
    [fire-Tonic-2]

end
to fire-Tonic-1
if Tonic-1 = "Yes"
 [fire 1]
end

to fire-Tonic-2
if Tonic-2 = "Yes"
 [fire 2]
end

;;///// Setup Procedures
to find-place ;;find a location for each input cell
set color green
let location 180 / number-of-inputs ;find equal distances for each cell
set heading 285 + (who * location)
fd 10
end

to ennumerate
ask inputs [set label who + 1]
end

to settype
set size 2
set shape "sphere"
ask inputs
  [if label = 1 [ifelse value-1 = "Exc" [set color green set value 1] [set color red set value 0]]
  if label  = 2 [ifelse value-2 = "Exc" [set color green set value 1] [set color red set value 0]]
  if label  = 3 [ifelse value-3 = "Exc" [set color green set value 1] [set color red set value 0]]
  if label  = 4 [ifelse value-4 = "Exc" [set color green set value 1] [set color red set value 0]]
  
   ]
end

to create-network
ask inputs [create-link-to one-of cells []]
end

;;this procedure is carried out at each iteration during a run to observe the effects of strength change
to set-strengths
ask inputs
  [if label = 1 [set strength strength-1]
  if label  = 2 [set strength strength-2]
  if label  = 3 [set strength strength-3]
  if label  = 4 [set strength strength-4]

   ]
end

to Make-cell
create-cells 1
ask cells [
set color cyan
set shape "sphere"
set size 3]
ask cells [set charge -70]
end

;;///// Plotting /////

to do-plot
  set-current-plot "Internal charge of Blue Cell"
  set-current-plot-pen "charge"
  set-plot-pen-interval 5000 
  plotxy ticks smoothed
end
@#$#@#$#@
GRAPHICS-WINDOW
429
62
867
301
17
8
12.24
1
10
1
1
1
0
1
0
1
-17
17
-8
8
1
1
1
ticks
30.0

BUTTON
42
21
105
54
NIL
setup\n
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

SLIDER
265
22
415
55
number-of-inputs
number-of-inputs
1
4
4
1
1
NIL
HORIZONTAL

TEXTBOX
142
72
292
91
Input Parameters
15
15.0
0

SLIDER
21
109
133
142
strength-1
strength-1
0
1
0.6
0.1
1
NIL
HORIZONTAL

SLIDER
21
158
134
191
strength-2
strength-2
0
1
0.9
0.1
1
NIL
HORIZONTAL

SLIDER
22
208
135
241
strength-3
strength-3
0
1
1
0.1
1
NIL
HORIZONTAL

SLIDER
23
257
136
290
strength-4
strength-4
0
1
1
0.1
1
NIL
HORIZONTAL

BUTTON
307
105
371
138
NIL
Fire 1
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
307
157
371
190
NIL
Fire 2
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
308
206
372
239
NIL
Fire 3
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
308
259
372
292
NIL
Fire 4
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
151
21
214
54
NIL
Go
T
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

PLOT
477
312
817
513
Internal charge of Blue Cell
Time
mV
0.0
50.0
0.0
10.0
true
false
"" ""
PENS
"charge" 1.0 0 -16777216 true "" ""

CHOOSER
22
347
160
392
Tonic-1
Tonic-1
"Yes" "No"
1

CHOOSER
22
396
160
441
Tonic-2
Tonic-2
"Yes" "No"
1

SLIDER
207
350
379
383
cycle-1
cycle-1
1
5
1
1
1
sec
HORIZONTAL

SLIDER
207
403
379
436
cycle-2
cycle-2
1
5
2
1
1
sec
HORIZONTAL

CHOOSER
158
100
250
145
value-1
value-1
"Exc" "Inh"
0

CHOOSER
157
150
252
195
value-2
value-2
"Exc" "Inh"
1

CHOOSER
157
201
254
246
value-3
value-3
"Exc" "Inh"
0

CHOOSER
157
254
254
299
value-4
value-4
"Exc" "Inh"
1

@#$#@#$#@
## WHAT IS IT?

This Model simulates the process of Signal Temporal Integration by neurons. The light blue neuron in the center of the screen receives inputs from a variable number of excitatory (green) and inhibitory (red) cells and responds to the inputs by integrating them (simple addition or subtraction). If the internal charge of the blue cell reaches threshold (-30 mV), it will simulate an action potential. 

## HOW IT WORKS

Each input to the central neuron may have a different "strength" which corresponds to its influence on the behavior of the central neuron. When an inhibitory cell fires, it will reduce the internal charge of the central neuron by an amount proportional to its strength. Excitatory cells cause the opposite effect.   
The central neuron is not a passive receptor of activity. If affected briefly, its internal charge will rebound to the resting potential after a second or so. Therefore, it takes a summation of inputs to get the central neuron to fire.  
Summation of inputs in this simulation is only temporal (cell's firing in close temporal proximity). 

## HOW TO USE IT

First select a number of inputs to the central neuron using the "number" slide. Then select the value (excitatory or inhibitory) for those neurons using the chooser switches. It is a good idea to start with a small number of neurons. If the Tonic switches are on "Yes" turn them to "No".   
Press the "Setup" button to create your system. Notice that each input neuron has a number label starting from 1. Those numbers correspond to the buttons and sliders of the input cells parameters. You may adjust the different strength of the inputs if you like.   
Press the "Go" button. You will see a straight line running in the plot at about -70mV, which corresponds to the resting potential of the central neuron.   
Now press any of the "Fire x" buttons. You will notice a deflection of the neuron's potential, downward for inhibitory, upward for excitatory, depending on the type of cell associated to each button. This corresponds to a "Phasic" neuron's firing.   
There are two "Tonic" cell buttons, corresponding to cells 1 and 2. By switching these buttons to Yes, you can have that cell fire automatically in a cycle determined by the "cycle" sliders. Using this capability, will allow you to produce synchronized firing by up to three cells (two tonic + one phasic). 


## THINGS TO NOTICE

As you will soon notice, repeated firing by inhibitory cells will only hyperpolarize the neuron transiently. Only repeated excitatory stimulation can result in an action potential. However, due to the cell's molecular machinery, even repetitive firing by excitatory cells needs to be close enough in time to get the central neuron to fire.

## THINGS TO TRY

Try running the model with Tonic neurons using different cycles and strenghts. At what strength can you reliably elicit an Action Potential from the central neuron at each cycle increment?  
If you set an inhibitory Tonic neuron at a cycle of 1 sec, how long does it take you to get the neuron to threshold by firing an phasic excitatory neuron? 

## EXTENDING THE MODEL

At the moment, summation is only temporal. Input cells's signals are integrated equally  regardless of their spatial proximity. Future models could include a simplified dendritic tree that takes into account the spatial proximity of firing inputs to the production of APs.

## CREDITS AND REFERENCES

This model is part of NeuroLab, a set of neuroscience-related simulations in NetLogo written by
Luis F. Schettino
Psychology Department 
Lafayette College 
Easton, PA, USA. 
https://sites.lafayette.edu/schettil
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

link
true
0
Line -7500403 true 150 0 150 300

link direction
true
0
Line -7500403 true 150 150 30 225
Line -7500403 true 150 150 270 225

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

sphere
false
0
Circle -7500403 true true 0 0 300
Rectangle -1 true false 180 75 225 120

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270

@#$#@#$#@
NetLogo 5.0.4
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 0.0 1.0
0.0 1 1.0 0.0
0.2 0 0.0 1.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180

@#$#@#$#@
0
@#$#@#$#@
