extensions [sound]
globals[X Y strip1 strip note-list flag selected cell-count Source-who Target-who]

breed[cells cell]
breed[notes note]
breed[sides side]

links-own [activation efficiency conduction-time]

cells-own [depolarized potential alias]
notes-own [value tone]


to setup
ca
ask patches [set pcolor 4]
set X nobody
set Y nobody
set Source 0
set Target 0
set cell-count 0

make-cells
ifelse Keyboard = "diatonic"
[make-keyboard1]
[make-keyboard2]
set selected no-turtles
ask links [set color 117]
reset-ticks
end


to go
  
 
  fire-tonics
 
  ask-concurrent cells [calculate-potential ] ;make sure cells fire in order
  
 
tick
end



to activate
fire cell-to-activate
end


to play-note
  
  let sound value
  set color pink
  ;;use the honky tonk piano 
  ;receive arguments for note
  sound:start-note "Honky-tonk Piano" sound 64 ;;60 is middle C
  wait 0.2
  sound:stop-note "Honky-tonk Piano" sound
  
end




;;//////// Blue Cell procedures /////

to fire [i]
ask cells [if label = i 
 [set potential -20
      ]]
end



;;if the cell's potential is higher than - 30mV it's set to depolarized and its color gets lighter
;;otherwise we bring down the internal charge by attenuating it
to calculate-potential
ifelse potential > -30 
   [set depolarized true set color 49 AP]
  [attenuate]
end

;;if the cell's potential deviates from its resting potential of -70mV, the attenuate procedure brings
;;it back slowly to it
to attenuate
ifelse potential < -70
 [set potential (potential + 0.03)]
 [set potential (potential - 0.03)] 
end



;;but if the cell is in a depolarized state (has reached threshold of -30 mV, we produce an action 
;;potential (AP)

to AP
ifelse depolarized = true
  [ifelse potential < 10
    [set potential (potential + 50) activate-efferents] ;;action potential
    [set depolarized false set potential -80 set color cyan recolor-key]];;go back down with a refractory period starting at -80
   [stop] 
end


to activate-efferents
  
ask my-out-links[ ;cells ask the keyboard notes
                    ask other-end [
                      ifelse breed = notes
                      [play-note]
                      [set potential (potential  + (abs potential *  [efficiency] of myself)) ]]];
  
 end

to recolor-key
  ask my-out-links[ ;cells ask the keyboard notes
                    ask other-end [
                      ifelse breed = notes ;only notes
                        [ifelse tone = "flat" ;flat ones turn
                           [set color white]  ;white
                           [set color black]]
                         [stop]
                         ]]
  
end


;;/////////////////////////LINKING Procedures////////////////////////

to see-link-strength
set flag flag + 1

ifelse flag mod 2 = 0
[ask links[
  set label ""] ]

[ask links[
  set label-color yellow
  set label efficiency]]
  
end

;this procedure became necessary in order to maintain a proper sequence of
;node numbers

to dereference-who
set Source-who item 0 ([who] of cells with [alias = Source]) ;de-reference the ID of
set Target-who item 0 ([who] of cells with [alias = Target]) ;Source and Target Nodes
  
end

to form-link
  
dereference-who

if Source-who = Target-who 
[user-message (word "cell cannot link to itself!") stop ]
  

if Source-who = 0 or Target-who = 0
[user-message (word "You need to define the source and target cells") stop ]

ask cell Source-who [create-link-to cell Target-who]


end

to kill-link
  
dereference-who


ifelse link (Source-who) (Target-who) = nobody
[user-message (word "You need to define the source and target cells") stop ]

  
[ask link (Source-who) (Target-who) [die]]
end

to set-link-type
  dereference-who
  
  
ifelse link (Source-who) (Target-who) = nobody
[user-message (word "You need to define the source and target cells") stop ]
 
 [ask link (Source-who) (Target-who) [
  ifelse value-1 = "Exc" 
    [set color green]
    [set color red]
    
   set thickness strength * 0.5
   ifelse color = green
    [set efficiency strength]
    [set efficiency strength * -1]]] ;control the sign of the activation
end
 

to choose-place

if mouse-down?
   [set X mouse-xcor 
    set Y mouse-ycor] 
end


to make-new-cell
 
 ifelse X = nobody
 [user-message (word "You need to run choose-place before you make a node") stop]
 
 
 [set cell-count cell-count + 1
   ask patch X Y [sprout 1
       [
         set breed cells
         set  shape "circle"
        set color cyan
        set size 3
        set alias cell-count 
        set label alias]]
 
 set X nobody
 set Y nobody]
end
;;/// Tonic Input procedures///  ADD INPUT BOXES SO THAT TONICS CAN AFFECT ANY NODE

to fire-tonics
 if ticks mod (cycle-1 * 50) = 0 ;ask tonics to fire every 50 ticks 
    [fire-Tonic-1]
 if ticks mod (cycle-2 * 50)= 0 ;ask tonics to fire every 50 ticks 
    [fire-Tonic-2]

end

to fire-Tonic-1
if Tonic-1 = "ON"
 [fire Tonic1]
end

to fire-Tonic-2
if Tonic-2 = "ON"
 [fire Tonic2]
end


;;////////////////////////////////SETUP procedures/////////////////////////////////


to make-keyboard1
  
  set note-list [59 60 62 64 65 67 69 71 72 74 76 77]
  let note-index 0
  
  foreach sort cells[ ;keys go from 11-21
    
    ask ? 
  
 [hatch 1[set heading 0 fd 10
                   set breed notes 
                   set color white
                   set shape "square"
                   set size 6
                   set label " "
                   set tone "flat"
                   set value item note-index note-list]
create-link-to min-one-of notes [distance myself]]
 set note-index (note-index + 1)]
  
;Label the notes

(foreach [-30 -25 -20 -15 -10 -5 0 5 10 15 20 25 ] ["B" "C" "D" "E" "F" "G" "A" "B" "C" "D" "E" "F"] 
      [ask patch ?1 19 [set plabel-color 27 set plabel ?2]])
end

to make-keyboard2
  
  set note-list [60 61 62 63 64 65 66 67 68 69 70 71]
  let note-index 0
  
  foreach sort cells[ ;keys go from 11-21
    
    ask ? 
  
 [hatch 1[set heading 0 fd 10
                   set breed notes 
                   set color white
                   set shape "square"
                   set size 6
                   set label " "
                   set tone "flat"
                   set value item note-index note-list]
create-link-to min-one-of notes [distance myself]]
 set note-index (note-index + 1)]
  
;Label the notes

(foreach [-30 -25 -20 -15 -10 -5 0 5 10 15 20 25 ] ["C" "C#" "D" "D#" "E" "F" "F#" "G" "G#" "A" "A#" "B"] 
      [ask patch ?1 19 [set plabel-color 27 set plabel ?2]])

foreach [14 16 19 21 23] [ask note ? [set color black set tone "sharp"]]
end

to make-cells 
  set strip1 patches with [pycor = 5 and abs pxcor < 33] 
  
  set strip strip1 with [pxcor mod 5 = 0] ;select the right patches
  
  
  foreach sort strip[
    
    set cell-count cell-count + 1
    
    ask ? [sprout 1 [ ;do it orderly to get the right labels for the cells
                      set breed cells
                      set color cyan
                      set size 4
                      set shape "circle"
                      set heading 0 ;to face notes and make link
                      set depolarized false
                      set potential -70
                      set alias cell-count 
                      set label alias
                      ]]]
  
  ask cell 12 [die] ;eliminate extra cell
  set cell-count cell-count - 1 ; reset cell count
end



;;//Procedures to save the modifications created by the user

to save-net

reset-ticks; and ticks
  
;build the filename
let wholename word filename ".csv"
  
export-world wholename
end

to load-net
  ;build filename
let wholename word filename ".csv"

  ifelse ( file-exists? wholename )
[import-world wholename ]
[ user-message "There is no such file in current directory!" ]
end

;kills a given cell with all its links
to kill-cell

  

ask cells [if alias = cell-to-kill [die]]
  
end

;///////////////MOVE PROCEDURES////////////////////////////
;These procedures were copied verbatim from the Mouse Drag Multiple Code Example
;available with NetLogo (Copyright 2007 Uri Wilensky). 

to Move
  if mouse-down?[
  ifelse selected? mouse-xcor mouse-ycor
      [ handle-drag
        deselect ]
      [ handle-select ]
  ]
end

to handle-select
  let old-x mouse-xcor
  let old-y mouse-ycor
  while [mouse-down?] [
    select old-x old-y mouse-xcor mouse-ycor
    display
  ]
  if not any? selected [ deselect ]
end

to handle-drag
  let old-x mouse-xcor
  let old-y mouse-ycor
  if selected? old-x old-y [
    while [mouse-down?] [
      let new-x mouse-xcor
      let new-y mouse-ycor
      
      ask selected
        [ setxy xcor + new-x - old-x
                ycor + new-y - old-y ]
      ask sides
        [ setxy xcor + new-x - old-x
                ycor + new-y - old-y ]
      set old-x new-x
      set old-y new-y
      
      display
    ]
  ]
end

to deselect
  ask sides [ die ]
  ask selected [ set color cyan ]
  set selected no-turtles
end


to select [x1 y1 x2 y2]   ;; x1 y1 is initial corner and x2 y2 is current corner
  deselect  ;; kill old selection rectangle
  make-side x1 y1 x2 y1
  make-side x1 y1 x1 y2
  make-side x1 y2 x2 y2
  make-side x2 y1 x2 y2
  set selected cells with [selected? xcor ycor]
  ask selected [ set color red ]
end

to make-side [x1 y1 x2 y2]
  ;; for each side, one thin line shape is created at the mid point of each segment
  ;; of the bounding box and scaled to the proper length
  create-sides 1 [
    set shape "line"
    set color pink
    setxy (x1 + x2) / 2
          (y1 + y2) / 2
    facexy x1 y1
    set size 2 * distancexy x1 y1
  ]
end

;; helper procedure that determines whether a point is
;; inside the selection rectangle
to-report selected? [xSel ySel]
  if not any? sides [ report false ]
  let y-max max [ycor] of sides   ;; largest ycor is where the top is
  let y-min min [ycor] of sides   ;; smallest ycor is where the bottom is
  let x-max max [xcor] of sides   ;; largest xcor is where the right side is
  let x-min min [xcor] of sides   ;; smallest xcor is where the left side is
  ;; report whether the input coordinates are within the rectangle
  report xSel >= x-min and xSel <= x-max and
         ySel >= y-min and ySel <= y-max
end
@#$#@#$#@
GRAPHICS-WINDOW
286
11
1199
564
35
20
12.732
1
10
1
1
1
0
0
0
1
-35
35
-20
20
0
0
0
ticks
30.0

BUTTON
22
11
85
44
NIL
setup\n
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

SLIDER
1323
283
1424
316
strength
strength
0
1
0.7
0.1
1
NIL
HORIZONTAL

BUTTON
175
172
250
205
NIL
Go
T
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

CHOOSER
1219
276
1311
321
value-1
value-1
"Exc" "Inh"
0

BUTTON
1339
214
1417
247
Set Link 
set-link-type
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

INPUTBOX
1218
180
1268
240
Source
41
1
0
Number

INPUTBOX
1272
181
1322
241
Target
3
1
0
Number

BUTTON
1349
344
1415
377
NIL
kill-link
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
1333
162
1422
195
NIL
form-link
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
1220
343
1345
376
NIL
see-link-strength
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
1216
89
1320
122
NIL
choose-place
T
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
1324
91
1422
124
NIL
make-new-cell
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

INPUTBOX
11
209
106
269
Cell-to-activate
13
1
0
Number

BUTTON
173
222
250
255
NIL
activate
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

TEXTBOX
15
182
165
200
Activation Procedures
11
54.0
1

TEXTBOX
1231
50
1381
68
Networking procedures
14
105.0
1

TEXTBOX
1238
143
1388
161
Link specs
14
115.0
1

BUTTON
12
123
83
156
NIL
save-net
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
95
122
159
155
NIL
load-net
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

INPUTBOX
177
24
280
84
filename
Twinkle-DW
1
0
String

CHOOSER
0
300
92
345
Tonic-1
Tonic-1
"OFF" "ON"
0

SLIDER
98
309
216
342
cycle-1
cycle-1
0
10
10
1
1
NIL
HORIZONTAL

SLIDER
101
380
215
413
cycle-2
cycle-2
0
10
8
1
1
NIL
HORIZONTAL

CHOOSER
0
367
92
412
Tonic-2
Tonic-2
"OFF" "ON"
0

INPUTBOX
222
292
276
352
Tonic1
26
1
0
Number

INPUTBOX
221
364
277
424
Tonic2
27
1
0
Number

CHOOSER
16
61
154
106
Keyboard
Keyboard
"diatonic" "chromatic"
0

INPUTBOX
1339
398
1407
458
cell-to-kill
21
1
0
Number

BUTTON
1250
410
1316
443
NIL
kill-cell
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
12
473
75
506
NIL
move
T
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

TEXTBOX
111
460
261
530
To move a cell or group of cells, use the mouse to draw a rectangle around them and drag them to the desired location.
11
0.0
1

@#$#@#$#@
## WHAT IS IT?

This Model allows the user to create a novel neural circuit that has as its output a melody. 

## HOW IT WORKS

At the top of the world is a keyboard whose keys can be played by activating the cells associated to them. The user creates new cells that are then connected to the cells that play the notes on the keyboard.    
The user can create as complex a circuit as the space will permit, adding excitatory and inhibitory cells with particular connection strengths.     
There are also up to two tonic neurons that can be asked to activate at regular intervals. 

## HOW TO USE IT

In order to create a circuit, the user presses on the Choose-Place button, and then uses the mouse to click on the world. Then the make-new-cell button is pressed which will create a note at the location of the previous mouse click.     
In order to link cells, the user enters the number of the source and target cells in the small input windows and presses 'form-link'. This will create an undefined link. In order to define its value (excitatory or inhibitory), the user clicks on the value-1 chooser to select EXC or INH. The strength of the link is set using the 'strength' slider. Finally, the user clicks the 'set-link' button to define the link.     
Any link can be readjusted or removed (pressing the 'kill-link' button) as long as the input values for source and target are correct. Notice that the relative strength of any link is shown by the thickness of the link.     
In order to activate the circuit, the user can press the 'activate' button which will bring a single cell to threshold 'cell-to-activate'.     
Two tonic cells can be defined by using the tonic1 and tonic2 input windows. Their cycle can be determined by the respective sliders.     
At the moment, only once cell's activity can be plotted. Entering the number of the cell in the input window will determine which cell's activity will be graphed.  The 'clear' button will clear the plot. 
The 'move' button allows the user to move a group of neurons at the same time while conserving their links. 

## THINGS TO NOTICE

The most important thing to notice is that each cell takes its turn to fire. This allows time to be represented in the circuit. So a chain of cells will fire in an ordered sequence. Knowing this can help organize a circuit in order for it to play a short melody.     
Pressing the 'see-link-strength' button will turn on and off the value of each link.

## THINGS TO TRY

Create a small circuit using both excitatory and inhibitory links to play a short song.
    

You can save your circuit by entering a file name in the 'filename' input window and pressing the 'save-net' button. This will save your net as a file named filename.csv, where filename is the name you entered. Use only a single word as filename to prevent errors.     
To re-load your circuit, simply enter the name again in the input window and press 'load-net'. 

## CREDITS AND REFERENCES 

This model is part of NeuroLab, a set of neuroscience-related simulations in NetLogo written by
Luis F. Schettino
Psychology Department 
Lafayette College 
Easton, PA, USA. 
https://sites.lafayette.edu/schettil
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 73 73 152
Rectangle -1 true false 180 105 195 120

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

link
true
0
Line -7500403 true 150 0 150 300

link direction
true
0
Line -7500403 true 150 150 30 225
Line -7500403 true 150 150 270 225

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

sphere
false
0
Circle -7500403 true true 0 0 300
Rectangle -1 true false 180 75 225 120

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270

@#$#@#$#@
NetLogo 5.0.4
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 0.0 1.0
0.0 1 1.0 0.0
0.2 0 0.0 1.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180

@#$#@#$#@
0
@#$#@#$#@
