;;Now that I added the statement "set attract-time ticks" to the attract-Nas procedure, I see
;;higher APs, but curiously, they seem to correspond to a higher K efflux???


turtles-own [speed];make sure the speed has a meaning
globals 
[ions ;;all ion particles
membrane;;the patches that make up the membrane
smoothed ;;the smoothed signal of the internal charge
hold-pump ;Boolean that prevents the Na/K pump from working during the AP
down-facing-Kchans

smooth-Na
smooth-K
internal-charge] ;;internal charge

breed[Ks K]
breed[Nas Na]
breed[channels channel]
breed[proteins protein]
breed[open-channels open-channel]

Ks-own
[charge
  attracted ;;boolean that indicates whether they have been pulled in... 
 partner ;;...by a channel who set them as partner 
 
 attract-time] 
Nas-own
[
  charge
  attracted ;;boolean that indicates whether they have been pulled in... 
 partner ;;...by a channel who set them as partner 
 attract-time
] 

proteins-own[charge]


channels-own[open-time partner attract-flag] ;;time channels remain open

open-channels-own [open-time partner attract-flag]

to setup
ca
set-sides
make-frame
make-ions ;produce the ions
make-membrane ;produce the membrane
make-frame
make-proteins
set hold-pump false

set smooth-Na 0
set smooth-K 0

set internal-charge -170 ;set cytoplasmic charge to negative values

reset-ticks
end


;;////////////////////////RUNTIME PROCEDURES////////////////////////////
to go
ask ions [bounce]
ask Nas[move-Nas]
ask Ks[move-Ks]
let-Ks-out
NaK-pump
control-membrane
calculate-charge
if internal-charge > 0 [expel-Ks] ;have K efflux respond to charge value
count-attracted
tick
end




;;The procedure NaK-Pump represents the sodium-potassium pump which makes sure Na ions are kept outside the 
;;cell membrane and brings in potassium ions instead. I am turning it off during the rise of the AP to prevent a too 
;;quick drop in the internal potential of the cell

to NaK-pump 
ifelse NaK-Pump-switch  
[
  
  
  ifelse hold-pump = false 
  [
    if any? Nas with [ycor < 0] and ticks mod 2 = 0
     [ask one-of Nas with [ycor < 0][random-position-up]] 
   

    ifelse count Ks with [ycor > 0] > 60 and count Ks with [ycor < 0] < 240
     [ask one-of Ks with [ycor < 0][random-position-down]
       ask down-facing-Kchans [set attract-flag false]]
     [ask down-facing-Kchans [set attract-flag true]]
     ]
  [if count Nas with [ycor < 0] > 80 
    [ask one-of Nas with [ycor < 0] [random-position-up]]]
  ] 
   
   
   
   
   
   
[stop];;if switch is off, don't run






end


to move-Nas
if ticks mod 3 = 0 [fd (0.25 * speed)]
if attracted = true
    [ifelse attract-time + 20 > ticks
      [ set speed 10 ] 
      [set speed 1 set attracted false set attract-time 0 ]];make sure attracted ions are not affected further by this procedure
end

to move-Ks
if ticks mod 3 = 0 [fd (0.25 * speed)]
if attracted = true
    [ifelse attract-time + 20 > ticks
      [ set speed 10 ] 
      [set speed 1 set attracted false set attract-time 0 ]];make sure attracted ions are not affected further by this procedure

end




to bounce  ;; particle procedure  ;; get the coordinates of the patch we will be on if we go forward 1
  
  ifelse patch-ahead 1 = nobody 
  [set heading 180 - heading] ;; if we're not about to hit a wall, we don't need to do any further checks
  
  [
    let new-patch patch-ahead 1
    let new-px [pxcor] of new-patch
    let new-py [pycor] of new-patch

 
    ifelse [pcolor] of new-patch = 47 or [pcolor] of new-patch = brown 
     
      [ set heading (180 - heading)]
       [ stop ]
  ]
end


;;//////////////////////////MEMBRANE PROCEDURES//////////////////////////////

to inject
  ifelse internal-charge < -70 ;respect the refractory period
  [stop]
  
[ifelse TTX = true
[expel-Ks]
[set hold-pump true
let-Nas-in]]
 
end

to let-Nas-in
ifelse TTX = true 
[ stop] ;;if TTX is added, prevent NA channel opening

[ask channels with [color = red] ;;
  [set open-time ticks
  set shape "open-receptor" 
  set size 11 
  ask patch-here [set pcolor black]]];;open space for sodium ions to get through and not bounce

end

to let-Ks-out
  ask  open-channels  
[
  ask patch-here [set pcolor black]] ;to eliminate the bounce 


end

to control-membrane
control-channels
;;K channels open when a given voltage is reached. In this case 35
;;If the substance TEA (a K channel blocker) is on, then prevent the opening of
;;K channels. 
if smoothed > 35 and TEA = false
[let-Ks-out]
end

;;This procedure controls the behavior of the channels by keeping them open for
;;a given amount of time and asking them to attract their appropriate species
to control-channels
  ask open-channels [ if attract-flag = true [attract-Ks]]
  
ask channels [
if shape = "closed"[stop]
if shape = "open-receptor" and color = red;;if you are open continue
    [ifelse ticks > (open-time + 150 ) 
      [close-Na-channels set hold-pump false]
      [attract-Nas]]
   if shape = "open-receptor" and color = cyan;;if you are open continue
    [ifelse ticks > (open-time  + 170) ;;let Ks flow out for a while
      [close-K-channels ]
      [attract-Ks]]
    
]
end

;;Attract asks channels to tell ions to move towards them and into or out of the
;;cell membrane, as appropriate, by setting their heading towards the channel and
;;increasing their speed momentarily

to attract-Nas
if color = red
[ask Nas in-cone 10 90[
  ifelse attracted = true
    [stop];make sure attracted ions are not affected further by this procedure
    [set attracted true;;set their boolean to true
      set attract-time ticks
     set partner myself
      facexy [pxcor] of partner [pycor] of partner ;;turn ions towards receptor patch
      set speed 15] ]];make them move fast towards the inside
end

to expel-Ks ;ask cyan receptors to open up
  
  ifelse TEA = true
  [stop]
[
  ask  channels  with [color = cyan] ;stagger K-channel opening
[set open-time ticks
set shape "open-receptor"
set size 11
ask patch-here [set pcolor black]] ;;make it look as though the channel opens
]
  
end

to attract-Ks
  
ask Ks in-cone 4 50[
  ifelse attracted = true
    [stop];make sure attracted ions are not affected further by this procedure
    [set attracted true;;set their boolean to true
      set attract-time ticks
     set partner myself
      facexy [pxcor] of partner [pycor] of partner ;;turn ions towards receptor patch
      ] ];make them move fast towards the inside
end
      


;;Close channels when their time is up and recolor the patch they are on
to close-Na-channels
ask channels with [color = red] [ask patch-here [set pcolor 47] set shape "closed" set size 12]

end

to close-K-channels

ask channels with [color = cyan] [ask patch-here [set pcolor 47] set shape "closed" set size 12]
end

;;/////////////////////PLOTTING PROCEDURES///////////////////////////////////


to calculate-charge
ifelse NaK-Pump-switch  
; to show that potential goes to zero with pump off
[set internal-charge (sum [charge] of proteins + sum [charge] of Nas with [ycor < 0]  + sum [charge] of  Ks with [ycor < 0] )]
[set internal-charge (sum [charge] of proteins + sum [charge] of Nas with [ycor < 0]  + sum [charge] of  Ks with [ycor < 0] )];
set smoothed 0.99 * smoothed + (1 - 0.99) * internal-charge; smooth signal 
end


to count-attracted
let in-Na count Nas with [ycor < 0]
set smooth-Na 0.99 *  smooth-Na + (1 - 0.99) * in-Na ;smooth the values before plotting
let in-Ks count Ks with [ycor < 0]
set smooth-K  0.99 *  smooth-K  + (1 - 0.99) * in-Ks
end
;;////////////////////////////SETUP PROCEDURES///////////////////////////
to set-sides
ask patch 10 21 [set plabel "EXTRACELLULAR SPACE" set plabel-color red]
ask patch 5 -21 [set plabel "CYTOPLASM" set plabel-color red]
ask patches ;set internal region to negative charge
[if pycor < 0
[set pcolor 1] ;make this region slightly lighter
if pycor > 0
[set pcolor 0]]
end

to make-frame
ask patches [
if  abs pycor = max-pycor [set pcolor brown]]
end

to make-ions
crt 600[
 ifelse who mod 2 = 0  ;; make one third Na, two thirds K
      [set breed Nas 
        set color blue 
        random-position-up 
        set speed 1 
        set charge 1.5
        set attracted false 
        set shape "dot" 
        set attract-time 0] ;;initialize as not-attracted
      
      [set breed Ks 
        set color green random-position-down  
        set speed 1 
        set charge 1
        set attracted false 
        set shape "dot" 
        set attract-time 0] ]

set ions turtles with [shape = "dot"] ;;put together in global 'ions'
ask ions [set size 2]
    
   
end

to make-proteins
  crt 25 [
           set breed proteins 
           set shape "protein"  
             set charge -12
             set color magenta  
             set size 5 
             setxy random world-width  (random 5 - 20) 
             set speed 0.1]
  
end

to make-membrane
ask patches with [pycor = 0] [set pcolor 47]
set membrane patches with [pcolor = 47]
make-channels
end

to make-channels
  ask membrane[
    without-interruption[ ;make always-open k channels
                          if pxcor mod 15 = 0 
                          [sprout 2 [set breed open-channels ]]]]
    
    ask open-channels [set shape "open-receptor" 
                       set color brown 
                       set size 13 
                       set attract-flag true
                       ifelse who mod 2 = 0 [set heading 0] [set heading 180]]
    
    set down-facing-Kchans open-channels with [heading = 180] ;
    
    ;make other ion channels
    ask membrane[
      if pxcor mod 6 = 0 and count open-channels-here = 0
    [sprout 1 [set breed channels set open-time 0]]]
    
      ask channels[
       
      set shape "closed" set size 13 
       ifelse who mod 2 = 0
        [set color red set heading 0];;sodium channels
        [set color cyan set heading 180] ];;potassium channels
  
  
end

to random-position-down ;; particle procedure
  setxy random world-width (random (20 * -1)) - 3
end

to random-position-up ;; particle procedure
  setxy random world-width random 15
end
@#$#@#$#@
GRAPHICS-WINDOW
17
312
1154
629
100
25
5.61
1
14
1
1
1
0
1
0
1
-100
100
-25
25
0
0
1
ticks
15.0

BUTTON
21
28
84
61
NIL
setup
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
22
99
85
132
NIL
go
T
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

PLOT
378
23
727
259
Potential
iterations
milivolts
0.0
10.0
0.0
10.0
true
false
"" ""
PENS
"default" 1.0 0 -16777216 true "" "plotxy ticks smoothed"

MONITOR
118
96
176
141
potential
smoothed
0
1
11

SWITCH
209
42
361
75
NaK-Pump-Switch
NaK-Pump-Switch
0
1
-1000

SWITCH
212
157
315
190
TTX
TTX
1
1
-1000

BUTTON
111
29
174
62
NIL
inject
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

PLOT
773
26
1101
261
Ion Currents
NIL
NIL
0.0
10.0
0.0
10.0
true
true
"" ""
PENS
"K-current" 1.0 0 -10899396 true "" "plotxy ticks smooth-K"
"Na-Current" 1.0 0 -13345367 true "" "plotxy ticks smooth-Na"

SWITCH
211
96
314
129
TEA
TEA
1
1
-1000

MONITOR
30
179
87
224
Ks OUT
count Ks with [pycor > 0]
17
1
11

MONITOR
122
178
179
223
Nas IN
count Nas with [pycor < 0]
17
1
11

@#$#@#$#@
## WHAT IS IT?

This model is designed to represent the establishment of the equilibrium potential of potassium ions across the neuronal membrane followed by a change of permeability of the membrane to sodium ions leading to an action potential.

## HOW IT WORKS

Neuronal activity depends on the ability of the cellular membrane to control the influx and efflux of ions across it. This "selective permeability" varies depending on the difference between the internal and external charges. In the "resting potential" the internal charge is negative with respect to the external charge due to the presence of large protein molecules within the cell. This difference in charges attracts positive ions into the cell. However, only K (potassium ions, in green) travels freely across the membrane through specialized K channels (brown). This free passage leads to an equilibrium state between the internal and external K concentrations.    
Furthermore, a continuous mechanism called the Na/K pump helps maintain the differential concentrations across the membrane by eliminating Na from the inside of the cell and bringing in K.  
Following natural or artificial stimulation, the cellular membrane may transiently alter its permeability to Na (sodium ions, in blue), allowing a brief influx of Na ions which causes a sharp increase in the internal charge (an Action Potential). 

## HOW TO USE IT

To start the model press on the Setup button. You will see the membrane running horizontally with the cytoplasm below, containing primarily K ions and the intercellular space above, containing primarily Na ions.

When the Go button is pressed, you will notice that the K ions will move freely across the membrane bringing the internal charge to a negative value (look at the graph on the left, it shows you the internal charge of the cell and the potential value monitor). When the number of K ions inside the membrane stabilizes, you will see the green line on the ions graph stay pretty much horizontal. This state represents the equilibrium potential for potassium. 

The model allows for manual opening of the voltage-gated Na channels on the membrane by pressing the button "inject".

## THINGS TO NOTICE

When the Action Potential is triggered, the voltage-gated Na channels open for a brief time allowing Na inside the cell. This will cause the charge within the cell to increase suddenly creating a sudden rise in the "potential" graph. Once the peak of Na ions is reached (equilibrium potential for sodium), voltage-gated K channels will open, letting K ions out of the cell, resulting in a sudden drop of charge within the cell. This rapid changes in the cell's internal charge produce a "spike" followed by a dip called the 'refractory period'.  
Following the Na entry and the K exit, the membrane regenerates its resting potential through the use of the Na/K pump which ships Na ions out and brings K ions in.  

## THINGS TO TRY

In order to define the processes leading to an Action Potential, Hodgkin, Huxley and Katz (from 1939 to 1952), experimented with the changes in membrane potential caused by the flow of K or Na ions through the cellular membrane. What happens when there is no Na in the model? What happens when you block the voltage-gated K channels with TEA, thereby impeding the exit of potassium during an Action Potential? What happens if you block the entry of Na ions by using TTX?  
Also, what happens to the resting potential if you turn off the Na/K pump?

## EXTENDING THE MODEL

The present Potentials Model is an abstraction of the true membrane and ionic behavior. Due to this, the values for the internal charge do not necessarily follow closely the observed data in actual physiological recordings. In the future, a Model based on the original Hodgkin-Huxley equations could produce more accurate results. 
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

closed
true
0
Polygon -7500403 true true 150 180 150 135 158 132 160 127 163 124 168 124 171 124 175 126 176 132 176 138 176 146 175 154 172 158 169 166 165 174 162 180 150 180
Polygon -7500403 true true 157 131 177 170
Polygon -7500403 true true 150 180 150 135 143 132 141 127 138 124 133 124 130 124 126 126 125 132 125 138 125 146 126 154 129 158 132 166 136 174 135 180 150 180

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

link
true
0
Line -7500403 true 150 0 150 300

link direction
true
0
Line -7500403 true 150 150 30 225
Line -7500403 true 150 150 270 225

open-receptor
true
0
Polygon -7500403 true true 158 184 158 136 158 132 160 127 163 124 168 124 171 124 175 126 176 132 176 138 176 146 175 154 172 158 169 166 165 174 162 180 158 184
Polygon -7500403 true true 157 131 177 170
Polygon -7500403 true true 143 184 143 136 143 132 141 127 138 124 133 124 130 124 126 126 125 132 125 138 125 146 126 154 129 158 132 166 136 174 139 180 143 184

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

protein
true
0
Polygon -7500403 true true 30 120 30 105 45 90 60 75 75 60 105 60 135 60 150 75 150 105 135 120 105 135 60 135 60 105 105 75 180 75 195 90 195 120 180 135 150 150 120 150 120 120 165 90 225 90 240 105 240 135 225 150 195 165 165 165 165 135 210 105 270 105 285 120 285 150 270 165 240 180 210 180 210 150 255 120 300 120 300 135 255 135 225 165 255 165 270 150 270 120 210 120 180 150 225 150 225 105 165 105 135 135 180 135 180 90 105 90 75 120 135 120 135 75 75 75 45 120

receptor
true
0
Polygon -7500403 true true 105 150 105 90 150 120 195 90 195 150 105 150
Polygon -7500403 true true 202 108 200 107

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270

@#$#@#$#@
NetLogo 5.0.4
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 0.0 1.0
0.0 1 1.0 0.0
0.2 0 0.0 1.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180

@#$#@#$#@
0
@#$#@#$#@
