;declare segments as large circles or ovoids to make the charge look more real. The chief could be used to declare two points
;and from them a vertical ellipse that is clipped at the membrane on both sides.[what about long segments??



turtles-own [speed];make sure the speed has a meaning

patches-own [active active-time my-segments];;variables for axon-chiefs


globals 
[ions ;;all ion particles
membrane;;the patches that make up the membrane
prop
axon-width
inside 
outside
axon-chiefs
GAP ;THE DISTANCEs BETWEEN CHANNELS
next
ONSET
OFFSET
run-number
myelin-thickness
pxcor-chief1
pxcor-chief2
No-Myelin-Flag
Latency] 

breed[Ks K]
breed[Nas Na]
breed[Na-Channels Na-Channel]
breed[K-Channels K-Channel]
breed[proteins protein]



Ks-own
[attracted ;;boolean that indicates whether they have been pulled in... 
 partner ;;...by a channel who set them as partner 
 attract-time
] 
Nas-own
[attracted
  partner
  attract-time
] 


Na-Channels-own[open-time partner my-patches chief] ;;time channels remain open
K-Channels-own[open-time partner] ;;time channels remain open

to setup
ca
set run-number 1
reset
make-ions
end

to reset
set axon-width 12 ;removed the control from interface
ask NA-channels [die]
ask K-channels [die]
make-membrane ;produce the membrane
set-sides
set-myelin-thickness 
make-myelin

set next 0
set pxcor-chief1 0
set pxcor-chief2 0
set prop false
set-axon-segments
set No-Myelin-Flag false
ask axon-chiefs [set active false]
set onset 0
set offset 0
ask Nas [random-position-out set speed 1 set attracted false set attract-time 0 set partner nobody]
reset-ticks
end


;;////////////////////////RUNTIME PROCEDURES////////////////////////////
to go
ask ions [bounce]
if ticks mod 250 = 0[activate-segments]

ask axon-chiefs [if ticks mod 50 = 0 [dwindle]]

ask Nas [move-Nas] 
ask Ks[move-Ks]
NaK-pump
control-channels
check-for-end
if [active] of patch 148 0  = true [stop-procedures stop]
tick
end

;to get all NA channels in a node of Ranvier to open at once
to activate-segments
  
  ifelse myelin-thickness = 0
  
  [
    if prop = true [
      
      ifelse No-Myelin-Flag = false 
      [
        ask patch next  0[set active true set active-time ticks ask my-segments [set pcolor 139]]
        set next next + 8]
    
      [
        let last-chief 0
        ifelse myelin >= 2 [set last-chief -148] [set last-chief -140]  
        ifelse next <= last-chief
       [ask patch next  0[set active true set active-time ticks ask my-segments [set pcolor 139]]
         set next next + 8]
        [ask patch last-chief 0 [set active false]]  ;ensure that the segments stop flashing
        ]
      ]
  ] 
  
  [if prop = true and next < (length gap) - 1[
  
  set pxcor-chief1 item next gap
  set pxcor-chief2 item (next + 1) gap
                      
                      
  ask patch pxcor-chief1  0[set active true set active-time ticks ask my-segments [set pcolor 139]]
  ask patch pxcor-chief2  0[set active true set active-time ticks ask my-segments [set pcolor 139]]
                           
  set next next + 2]]
 
  
end

;;This procedure controls the actual propagation. 


to dwindle
  
 
    
    if active = true ;if active is on
     [
      ifelse ticks >= active-time + 100 ;and active time is  up
          [set active false] 
          [stop]
     ]
     
     if active = false
       [ifelse  pcolor > 136  ;otherwise if color is high
            [ask my-segments [set pcolor pcolor - 0.5] ] ;begin reducing it
            [stop] ];when color is normal stop
         

end




to NaK-pump 
  
    if any? Nas with [ycor < axon-width] and ticks mod 2 = 0
     [ask one-of Nas with [ycor < axon-width][random-position-out]] 
   

    if count Ks with [ycor > axon-width] > 60 and count Ks with [ycor < axon-width] < 240
     [ask one-of Ks with [ycor < axon-width][random-position-in]]
       
end

to move-Nas
  
if ticks mod 3 = 0 [fd (0.25 * speed)]  

check-direction

ifelse attracted = true
       [  head-forward
          ifelse attract-time + 10 > ticks
                [ set speed ((myelin-thickness * 3) + 2) ] ;;In saltatory conduction, the speed at which NAs come in is higher
                [set speed (0.25 * speed) set attracted false set attract-time 0 ]];make sure attracted ions are not affected further by this procedure
    [stop]
    
end

;WHAT IS THIS DOING???
to check-direction
  if xcor < min-pxcor [ set speed 1 set attracted false set attract-time 0 random-position-out]
end

to head-forward
  ifelse [pcolor] of patch-here = pink
        [if heading > 170 or heading < 15
                      [set heading random 145]
         set speed speed - 0.5 ];reduce the speed of ions as they move through lumen
  [stop]
end


to move-Ks
if ticks mod 3 = 0 [fd (0.25 * speed)]
if attracted = true
    [ifelse attract-time + 20 > ticks
      [ set speed 10 ] 
      [set speed 1 set attracted false set attract-time 0 ]];make sure attracted ions are not affected further by this procedure

end



to bounce  ;; particle procedure  ;; get the coordinates of the patch we will be on if we go forward 1
  if [pcolor] of patch-here = 3 [random-position-out]
  
let new-patch patch-ahead 1
  
  let new-px [pxcor] of new-patch
  let new-py [pycor] of new-patch

 
 if breed = nas 
   [ifelse [pcolor] of new-patch = 47 or [pcolor] of new-patch = 3 or abs pycor > axon-width + 10 or [pcolor] of new-patch = 1;keep Nas close
     [ set heading (180 - heading)]
     [stop]]
     
  if breed = Ks
     [ifelse [pcolor] of new-patch = 3  or [pcolor] of new-patch = 47
       [ set heading (180 - heading)]
       [ stop ]]
       
      if breed = proteins ;or breed = att-ions
  [ifelse [pcolor] of new-patch = 47 
    [ set heading (180 - heading)]
     [stop]]
   
end

to stop-procedures

set Latency Offset - Onset
set run-number run-number + 1
  
ask inside [set pcolor 136]
  
end


;;//////////////////////////MEMBRANE PROCEDURES//////////////////////////////

;;;///////PUNCTUATED PROCEDURES///
to inject

 
  if myelin-thickness = 0 
  [set next -156]
  

set prop true
set ONSET ticks

end



to let-Nas-in
set open-time ticks
set shape "open-receptor" 
set size 13 

ask patch-here [set pcolor black];;open space for sodium ions to get through and not bounce
end


to expel-Ks ;ask cyan receptors to open up
set open-time ticks
set shape "open-receptor"
set size 13
ask patch-here [set pcolor 1] ;;make it look as though the channel opens
end

to check-for-end
  
  if [active] of patch 148 0 = true
  [set OFFSET ticks]
 
  
  
end


 ;; //////////////////////////////LOOP PROCEDURES/////////////////////////////////////


to control-channels
 
  
ask Na-Channels [
if shape = "closed" and [active] of chief = true [let-Nas-in]
  
  
if shape = "open-receptor" ;;if you are open continue
    [ifelse ticks > (open-time + 100 ) 
      [close-Na-channels ]
      [attract-Nas]]
]
    
ask K-Channels  [ 
  
   if shape = "closed"[if any? neighbors with [pcolor = 138] [expel-Ks]]
   if shape = "open-receptor" ;;if you are open continue
    [ifelse ticks > (open-time  + 300) ;;let Ks flow out for a while
      [close-K-channels ]
      [attract-Ks]]
]

end

 
to attract-Nas 
      ask Nas in-cone 10 90[
                             ifelse attracted = true
                              [stop];make sure attracted ions are not affected further by this procedure
                              [set attracted true;;set their boolean to true
                               set attract-time ticks
                               set partner myself
                               facexy [pxcor] of partner [pycor] of partner ;;turn ions towards receptor patch
                             ]  
                              ]
end

to attract-Ks
  
ask Ks in-cone 4 50[
                     ifelse attracted = true
                       [stop];make sure attracted ions are not affected further by this procedure
                       [set attracted true;;set their boolean to true
                        set attract-time ticks
                        set partner myself
                        facexy [pxcor] of partner [pycor] of partner ;;turn ions towards receptor patch
                      ] ]
end
      




;;Close channels when their time is up and recolor the patch they are on
to close-Na-channels
ask Na-Channels[ask patch-here [set pcolor 47] set shape "closed" set size 14]

end

to close-K-channels

ask K-Channels [ask patch-here [set pcolor 47] set shape "closed" set size 14]
end




;;////////////////////////////SETUP PROCEDURES///////////////////////////

to make-membrane
set inside patches with [abs pycor < axon-width] ;width of axonal lumen controls outside 
set outside patches with [abs pycor > axon-width];vs. inside
set membrane patches with [abs pycor = axon-width];the patches that will be the membrane

ask membrane [set pcolor 47]

ask membrane [
if pxcor mod 4 = 0
    [sprout 1
      [set breed Na-Channels set shape "closed" set size 14 set open-time 0
      set color red 
      set chief patch xcor 0]]];;make all sodium channels

ask Na-Channels [
if xcor mod 8 = 0 ;;then ask half of them to become
      [set breed K-Channels set shape "closed" set size 14 set color cyan set open-time 0 ];;....potassium channels
  
;;;define the portions of the axonal lumen that each top sodium channel is responsible for
;;namely, EIGHT patches in the forward direction 

  if ycor > 0 and color = red
    [set my-patches patches with 
          [(abs pycor < axon-width  and pycor < [ycor] of myself)  and (pxcor <= [xcor] of myself + 7 and pxcor > [xcor] of myself - 1)]]

;;Ask channels to look out if Nas and in if Ks on both sides of the membrane
facexy xcor 0
set heading heading + 180]

ask K-Channels [facexy xcor 0]
end


to set-sides
ask patch 10 27 [set plabel "EXTRACELLULAR SPACE" set plabel-color red]
ask patch 5 0   [set plabel "AXONAL LUMEN" set plabel-color 75]
ask inside
[set pcolor 136] ;color the lumen different from extracellular space
ask outside
[set pcolor 0]
end

to make-ions
crt 300 [set breed Nas set color blue  set speed 1 set attracted false set attract-time 0 set shape "dot" set size 3] 
crt 300 [set breed Ks set color green  set speed 1 set attracted false set attract-time 0 set shape "dot" set size 3]

set ions turtles with [shape = "dot"] ;;put together in global 'ions'

ask  Ks [ifelse who mod 3 = 0[random-position-out] [random-position-in]]

ask Nas [random-position-out]
end


to random-position-out ;; particle procedure

ifelse who mod 2 = 0
  [setxy random world-width random (5) + axon-width + 1 
   if [pcolor] of patch-here = 3 [random-position-out]]
  [setxy random world-width (random (5) + axon-width + 1) * -1 
   if [pcolor] of patch-here = 3 [random-position-out]] 
end


to random-position-in ;; particle procedure
ifelse who mod 2 = 0
  [setxy random world-width random (axon-width - 1)]
   [setxy random world-width random (axon-width - 1) * -1]
end


to make-proteins
create-proteins 50 [
  set shape "protein" 
  set color magenta  
  set size 5 
  random-position-in 
  set speed 0.1]
end

to set-myelin-thickness

if myelin = 0
[no-myelin]
if myelin = 1
[thin-myelin]
if myelin = 2
[mid-myelin]
if myelin = 3
[thick-myelin]
end

to no-myelin
  set myelin-thickness 0
end
to thin-myelin
  set myelin-thickness 2
end
to mid-myelin
  set myelin-thickness 4
end
to thick-myelin
  set myelin-thickness 6
end


;;USE THE MY-PATCHES GROUPS TO DEFINE SECTIONS WITHIN EACH MYELINATED SEGMENT

;;The length of the myelin segments depends on the thickness of the myelin layer. Thicker layers correspond to longer segments
to make-myelin
  let seg-onsets [ ]
  let seg-length 0
  
if myelin-thickness = 2
[set seg-onsets [-136 -80 -24 30 85] set seg-length 40]
  
if myelin-thickness = 4
[set seg-onsets [-140 -66  10 85] set seg-length 60]
  
if myelin-thickness = 6
[set seg-onsets [-140  8 ] set seg-length 130]


foreach  seg-onsets ;these are the segment starts
[ask patches [if pxcor = ?1 and abs pycor <= (axon-width + myelin-thickness) and abs pycor > axon-width 
    [sprout 1 
      [set heading 90 repeat seg-length 
        [ask patch-here [set pcolor 3] fd 1] die] ]]]


;;the top line tapers down 
ask patches [if abs pycor = (axon-width + myelin-thickness) and count neighbors with [pcolor = 3] = 3 [set pcolor black]]


  
  
ask K-Channels[
if any? neighbors4 with [pcolor = 3] [die]]
;;;kill sodium channels
ask Na-Channels[
if any? neighbors4 with [pcolor = 3] [die]]
end

;each portion of the axon is divided into segments that are controlled by a center patch so the whole node of ranvier is activated
;as a single entity

to set-axon-segments
  ask Na-Channels with [pycor > 0][ ask patches with [pxcor = [pxcor] of myself and pycor = 0] [set pcolor lime]]
  set axon-chiefs patches with [pcolor = lime]
  ask axon-chiefs [set pcolor 136]
  
  
  ask axon-chiefs [
    set active false
    set active-time 0
    
    if myelin-thickness = 0 ;For no-myelin there are 40 axon-chiefs, segments are 3 before and 4 after, the three prevents the overlap
    
    [set my-segments patches with [pxcor <= [pxcor] of myself + 4 and pxcor >= [pxcor] of myself - 3  and abs pycor <= axon-width - 1]
      ] 
    
    
  if myelin-thickness = 2;for myelin = 2, there are 16 axon-chiefs, segments are 3 before and 4 after, the three prevents the overlap
    [set my-segments patches with [pxcor <= [pxcor] of myself + 4 and pxcor >= [pxcor] of myself - 3 and abs pycor <= axon-width - 1]
    set gap [-148 -140 -92 -84 -36 -28 20 28 76 84 132 140 148 156 ]
    ;DO SPECIAL FOR THE LONG MYELIN SEGMENTS
    ask patch -140 0 [set my-segments patches with [pxcor <= ([pxcor] of myself + 44) and pxcor >= ([pxcor] of myself - 3) and abs pycor <= axon-width - 1]]
    ask patch -84 0 [set my-segments patches with [pxcor <= [pxcor] of myself + 44 and pxcor >= [pxcor] of myself - 3 and abs pycor <= axon-width - 1]]
    ask patch -28 0 [set my-segments patches with [pxcor <= [pxcor] of myself + 44 and pxcor >= [pxcor] of myself - 3 and abs pycor <= axon-width - 1]]
    ask patch 28 0 [set my-segments patches with [pxcor <= [pxcor] of myself + 44 and pxcor >= [pxcor] of myself - 3 and abs pycor <= axon-width - 1]]
    ask patch 84 0 [set my-segments patches with [pxcor <= [pxcor] of myself + 44 and pxcor >= [pxcor] of myself - 3 and abs pycor <= axon-width - 1]]
    ask patch 140 0 [set my-segments patches with [pxcor <= [pxcor] of myself + 44 and pxcor >= [pxcor] of myself - 3 and abs pycor <= axon-width - 1]]]
    
    
    
    
    
if myelin-thickness = 4;for myelin = 4, there are 10 axon-chiefs, segments are 3 before and 4 after, the three prevents the overlap
    [set my-segments patches with [pxcor <= [pxcor] of myself + 4 and pxcor >= [pxcor] of myself - 3 and abs pycor <= axon-width - 1]
      set gap [-156 -148 -76 -68 -4 4 76 84 148 156 ]
    ask patch -148 0 [set my-segments patches with [pxcor <= [pxcor] of myself + 68 and pxcor >= [pxcor] of myself - 3 and abs pycor <= axon-width - 1]]
    ask patch -68 0 [set my-segments patches with [pxcor <= [pxcor] of myself + 60 and pxcor >= [pxcor] of myself - 3 and abs pycor <= axon-width - 1]]
    ask patch 4 0 [set my-segments patches with [pxcor <= [pxcor] of myself + 67 and pxcor >= [pxcor] of myself - 3 and abs pycor <= axon-width - 1]]
    ask patch 84 0 [set my-segments patches with [pxcor <= [pxcor] of myself + 68 and pxcor >= [pxcor] of myself - 3 and abs pycor <= axon-width - 1]]]
 
    
    
    
if myelin-thickness = 6;for myelin = 4, there are also 10 axon-chiefs, segments are 3 before and 4 after, the three prevents the overlap
    [set my-segments patches with [pxcor <= [pxcor] of myself + 4 and pxcor >= [pxcor] of myself - 3 and abs pycor <= axon-width - 1]
       set gap [-156 -148  -4  4 140 148 156 ]
  ask patch -148 0 [set my-segments patches with [pxcor <= [pxcor] of myself + 140 and pxcor >= [pxcor] of myself - 3 and abs pycor <= axon-width - 1]]
    ask patch 4 0 [set my-segments patches with [pxcor <= [pxcor] of myself + 140 and pxcor >= [pxcor] of myself - 3 and abs pycor <= axon-width - 1]]]
  
  
  ]
 end




;;THIS PROCEDURE SHOULD KILL THE HIDDEN NA CHANNELS AND ALLOW THE CHARGE TO DISSIPATE AS IT TRAVELS
;;DOWN THE AXON WITHOUT REACHING THE NODES
to destroy-myelin
;ask Na-Channels [if any? neighbors4 with [pcolor = 3]
;[set hidden? true] ] ;;keep K channels hidden
ask patches[if pcolor = 3 [set pcolor 0]] ;;then eliminate myelin
set myelin-thickness 0
set No-Myelin-Flag true
 ask axon-chiefs [
    set active false
    set active-time 0
    set my-segments patches with [pxcor <= [pxcor] of myself + 4 and pxcor >= [pxcor] of myself - 3  and abs pycor <= axon-width - 1]
      
 ]
end
@#$#@#$#@
GRAPHICS-WINDOW
15
220
1309
495
160
30
4.0
1
14
1
1
1
0
1
1
1
-160
160
-30
30
0
0
1
ticks
30.0

BUTTON
75
37
138
70
NIL
setup
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
430
35
493
68
NIL
go
T
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
434
100
497
133
NIL
inject
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
211
37
324
70
NIL
destroy-myelin
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

SLIDER
212
100
384
133
myelin
myelin
0
3
3
1
1
NIL
HORIZONTAL

BUTTON
539
31
627
90
NIL
reset
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

TEXTBOX
795
27
945
61
Latencies are reported in arbitrary units
14
103.0
1

MONITOR
956
29
1038
74
NIL
Latency
17
1
11

@#$#@#$#@
## WHAT IS IT?

This model represents the propagation of the Action Potential down a neuronal axon. Axons are hollow fibers that project from the main body (or soma) of a neuron and connect it to other neuron(s). 
Action potentials, as any other electrical signal, tend to decay as they propagate from their original sources. In order to prevent such decay, neurons regenerate the signal through the opening of voltage-sensitive sodium channels on the axonal membrane (similar to the generation of an Action Potential at the soma). 
Conduction speeds of the action potential in vertebrates are greatly enhanced through myelin coating of portions of the axon. Myelin, a fatty substance, prevents the loss of charge within the axon for longer distances and allows for a saltatory (skipping) type of impulse propagation between the portions of the membrane that contain voltage-gated channels (termed Nodes of Ranvier). Thicker myelination allows for longer distances between nodes and leads to faster conduction speeds 

## HOW IT WORKS

The simulation allows for the comparison of different amounts of myelin on the axon. Pressing the SETUP button with the myelin slider at zero will create an axon segment whose membrane is covered in sodium-channels (red) and potassium-channels (cyan). 
Pressing the GO button will set the ions (sodium, blue and potassium, green) in motion. The INJECT button will then initiate the impulse at the left margin. Sodium channels will open, allowing sodium ions to come in, followed by the opening of potassium channels and the exit of those ions. 

## HOW TO USE IT

In order to compare the different conduction speeds, move the myelin slider to produce or thicken the amount of myelin on the axonal membrane, press the RESET button and then run the program by pressing GO and INJECT. The reporter window will show the latency for each run in arbitrary units. Pressing SETUP will erase the reporter window's contents.

## THINGS TO NOTICE

Notice that potassium channels open after their neighboring sodium channels open. The refractory period of the Action Potential is also present at the axon in the Nodes of Ranvier. In the axon, the refractory period prevents the newly generated Action Potential from propagating backwards. 



## THINGS TO TRY

One of the most important functions of fast conduction speeds in the nervous system is the coordination of motor output. Disorders that destroy myelin such as Multiple Sclerosis result in a number of symptoms including paralysis, weakness and loss of coordination.
Pressing the Destroy-Myelin button in any of the myelin-bearing axons will show that conduction of the impulse is no longer possible in the absence of myelin. While an abrupt disruption of conduction is observed in the model, in patients the process is slow as myelin is slowly destroyed at a faster rate than it can be regenerated.  



## CREDITS AND REFERENCES

This model is part of NeuroLab, a set of neuroscience-related simulations in NetLogo written by
 Luis F. Schettino
Psychology Department 
Lafayette College 
Easton, PA, USA. 
https://sites.lafayette.edu/schettil
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

closed
true
0
Polygon -7500403 true true 150 180 150 135 158 132 160 127 163 124 168 124 171 124 175 126 176 132 176 138 176 146 175 154 172 158 169 166 165 174 162 180 150 180
Polygon -7500403 true true 157 131 177 170
Polygon -7500403 true true 150 180 150 135 143 132 141 127 138 124 133 124 130 124 126 126 125 132 125 138 125 146 126 154 129 158 132 166 136 174 135 180 150 180

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

link
true
0
Line -7500403 true 150 0 150 300

link direction
true
0
Line -7500403 true 150 150 30 225
Line -7500403 true 150 150 270 225

open-receptor
true
0
Polygon -7500403 true true 158 184 158 136 158 132 160 127 163 124 168 124 171 124 175 126 176 132 176 138 176 146 175 154 172 158 169 166 165 174 162 180 158 184
Polygon -7500403 true true 157 131 177 170
Polygon -7500403 true true 143 184 143 136 143 132 141 127 138 124 133 124 130 124 126 126 125 132 125 138 125 146 126 154 129 158 132 166 136 174 139 180 143 184

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

protein
true
0
Polygon -7500403 true true 30 120 30 105 45 90 60 75 75 60 105 60 135 60 150 75 150 105 135 120 105 135 60 135 60 105 105 75 180 75 195 90 195 120 180 135 150 150 120 150 120 120 165 90 225 90 240 105 240 135 225 150 195 165 165 165 165 135 210 105 270 105 285 120 285 150 270 165 240 180 210 180 210 150 255 120 300 120 300 135 255 135 225 165 255 165 270 150 270 120 210 120 180 150 225 150 225 105 165 105 135 135 180 135 180 90 105 90 75 120 135 120 135 75 75 75 45 120

receptor
true
0
Polygon -7500403 true true 105 150 105 90 150 120 195 90 195 150 105 150
Polygon -7500403 true true 202 108 200 107

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270

@#$#@#$#@
NetLogo 5.0.4
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 0.0 1.0
0.0 1 1.0 0.0
0.2 0 0.0 1.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180

@#$#@#$#@
0
@#$#@#$#@
