globals[
signal1 smoothed1 
signal2 smoothed2
signal3 smoothed3
elements
right-object
   ]
breed[expers exper];turtles that represent 'experience'
breed[dot2s dot2]
breed[receps recep]
breed[cells cell]
breed[inters inter]
breed[drops drop]
breed[objects object]
directed-link-breed[segs seg] ;breed of links
directed-link-breed[axons axon] ;breed of lin
directed-link-breed[arrows arrow]


links-own [activation]

cells-own [ col total-activation total-inhibition activity]
receps-own [ col dist total-activation activity]
inters-own [ col total-activation activity]
expers-own [ col total-activation]
dot2s-own [ col total-activation  activity]





to setup
ca
  
produce-cells
set elements turtles with [ycor < 8 and ycor > -9]
ask elements [ set total-activation 0   set col color
                if pxcor >= 20 [die]] ;get rid of the extra cells ;CLEAN THIS UP
  
 
  
connect-cells
  
ask links[ set color green set activation 0]
  ask dot2s [ask my-out-links [set color red]]
  ask inters [ask my-out-links [set color red]]
  ask cells [if who >= 1 and who <= 3 [set label who set label-color black]]
  make-object
  set right-object max-one-of objects [xcor]
  ask patch 2 -14 [set plabel "EXPERIENCE" set plabel-color black]
  reset-ticks
end



to go
  tick
 if slide-object [if ticks mod 20 = 0 [ask objects [go-for-it]]]
 if [xcor] of right-object = 18 [stop]
  ask receps [ifelse any? objects in-cone 8 180 [fire] [turn-off]]
  ask elements [activate-cells ]
  ask expers[light-up] 
  make-signals
  do-plots
  
end



;;//////// Cell procedures /////


;Receptors run this procedure looking at the distance to any of the objects. The closer they are, the
; stronger they activate. They pass the activation to the cells
to fire 
  
let this-one  min-one-of objects [distance myself]
set dist (distance this-one ) 

  if dist > 6 [set activity 1]
  if dist < 6 and dist >= 5 [set activity 2]
  if dist < 5 [set activity 3]

    
    ask my-out-links ;;if I am activated, turn yellow
 [set activation [activity] of myself]
     
end

to turn-off
  set activity 0
  ask my-out-links [set activation 0]
end

to activate-cells
  
  color-cells
  
  if breed = receps
  [
    set total-activation activity
   ]
  
 
  
  if breed = cells
  [
   set total-activation [activation] of in-link-from recep (who + 21) 
   set total-inhibition sum [total-activation] of dot2s in-radius 2 
  
   
   set activity (total-activation - total-inhibition)
   
   ;if activity >= 3 [set total-activation 3]
   ;f activity < 3 and activity >= 2.1[set total-activation 2]
   ;if activity < 2 and activity > 0 [set total-activation 1]
   
   
   ask my-out-links [set activation [activity] of myself]
   
  ]
  
  if breed = inters
  [
   set activity sum [activation] of my-in-links 
   
   if activity >= 3 [set activity 3]
   if activity < 3 and activity >= 2.1[set activity 2]
   if activity < 2 and activity > 0 [set activity 1]
   if activity <= 0 [set activity 0]
  
   set total-activation activity
   ask my-out-links [set activation [activity] of myself]
   ]
  
   if breed = dot2s
   [
     set total-activation sum [activation] of my-in-links ]
 

end

to light-up
  
  set total-activation sum [activation] of my-in-links 
  
  ;trickle down the color
   if total-activation < 1 [set color 101] 
   if total-activation >= 0 [set color 7]
  if total-activation >= 1  [set color 48]
if total-activation >= 2 [set color yellow]
  
  
end

to color-cells
  
  if total-activation > 2 [set color 49] 
  if total-activation >= 1 and total-activation < 2  [set color col + 3]
  if total-activation < 1 and total-activation > 0.5 [set color col + 2]
   if total-activation < 0.5 [set color col] 
end


;/////////////////////////////////////////////////////////////////////////////////////////////////////////



to connect-cells
  ask receps [set heading 180 create-axons-to cells in-cone 12 2 set heading 0]

  ask cells [set heading 180 create-axons-to inters in-cone 5 90
             create-arrows-to expers in-cone 12 2]
  ask inters[ifelse who mod 2 = 0
               [set heading 333] 
               [set heading 26] 
               
               create-segs-to dot2s in-cone 8 2]
  
  ask dot2s [set heading 0 create-axons-to cells in-radius 3 ]
  ask axons [set shape "axon2"]
  ask segs [set shape "seg"]
  ask arrows[set shape "arrow" set color yellow]
  
end

to do-plots
set smoothed1 (0.9 * smoothed1 + 0.1 * signal1) ;smooth activation signal
set smoothed2 (0.9 * smoothed2 +  0.1 * signal2)  ;smooth activation signal
set smoothed3 (0.9 * smoothed3 +  0.1 * signal3) ;smooth activation signal
  
  
  set-current-plot "Cell Activity"
  set-current-plot-pen "c1"
  plotxy ticks smoothed1 + 10
  set-current-plot-pen "c2"
   plotxy ticks smoothed2 + 5
   set-current-plot-pen "c3"
   plotxy ticks smoothed3
  
  
end



to move-right
ask objects[set heading 90 fd 1]  
 
  
end

to move-left
ask objects[set heading 90 bk 1]  
 
  
end
to produce-cells
  
ask patches[ifelse pycor = 6 and abs pxcor < 22 [set pcolor 36] [set pcolor 7]];make epithelium

foreach sort patches with [pycor = -4 and abs pxcor < 22] ;;make cells
    [ask ?
          [if pxcor mod 6 = 0 
                [sprout 1
                    [set breed cells set size 3 set color cyan set shape "circle"]]]]
   
foreach sort patches with [pycor = -8 and abs pxcor < 22] ;;make inters
    [ask ?
          [if pxcor mod 6 = 0 
                [sprout 1
                    [set breed inters set size 2 set color magenta set shape "circle"
                      set heading 90 fd 2 hatch 1 [fd 2]]]]] ;have each inter create its twin
    
  
foreach sort patches with [pycor = 5 and abs pxcor < 22] ; make receptors
    [ask ?
          [if pxcor mod 6 = 0 
                [sprout 1
                    [set breed receps set size 4 set color red set shape "circle" set dist 0]]]]
    


     
    
  foreach sort patches with [pycor = -4 and abs pxcor < 22] ;;make dot2s
    [ask ?
          [if pxcor mod 6 = 0 
                [sprout 1
                    [set breed dot2s set size 0.3 set color red set shape "dot"
                      set heading 90 fd 2 hatch 1 [fd 2]]]]] ;have each inter create its twin      
              
    
    
  foreach sort patches with [pycor = -11 and abs pxcor < 22] ;make dot1s
    [ask ?
          [if pxcor mod 6 = 0 
                [sprout 1
                    [set breed expers set size 4 set color 7 set shape "square 2" ]]]]         
              
                   
    
  
  
  
  
end

to make-signals
set signal1 round [activity] of cell 1  ;;create a signal from activity of test cell1
set signal2 round [activity] of cell 2  ;;create a signal from activity of test cell1
set signal3 round [activity] of cell 3  ;;create a signal from activity of test cell1
end

to remove-inhibition

ask dot2s [die]
ask inters [set total-activation 0 set activity 0]
  
end

to replace-inhibition
 foreach sort patches with [pycor = -4 and abs pxcor < 22] ;;make dot2s
    [ask ?
          [if pxcor mod 6 = 0 
                [sprout 1
                    [set breed dot2s set size 0.3 set color red set shape "dot"
                      set heading 90 fd 2 hatch 1 [fd 2]]]]] ;have each inter create its twin    
    
    ask dot2s [ set total-activation 0   set col color
                if pxcor >= 20 [die]] ;get rid of the extra cells ;CLEAN THIS UP  
              
ask dot2s [set heading 0 create-axons-to cells in-radius 3 ] 

  
  ask dot2s [ask my-out-links [set color red] set total-activation sum [activation] of my-in-links ]
  ask inters [ create-segs-to dot2s  in-cone 8 2 ask segs [set shape "seg" set color red]]
    set elements turtles with [ycor < 8 and ycor > -9]
end


 to make-object
   
   ifelse two-objects
  
   
  [ask patch -18 8 [sprout 1 [set breed objects  set color green set shape "object" set size 6 set heading 90]]
  
  ask patch -6 8[sprout 1 [set breed objects  set color green set shape "object" set size 6 set heading 90]]]
  
   [ ask patch -18 9 [sprout 1 [set breed objects  set color green set shape "object" set size 10 set heading 90]]]
end
 
 to go-for-it
  set right-object max-one-of objects [xcor]
   
   ifelse [xcor] of right-object < 20 [fd 1] [stop]
   
   
   
 end
@#$#@#$#@
GRAPHICS-WINDOW
535
20
995
361
22
15
10.0
1
10
1
1
1
0
0
0
1
-22
22
-15
15
0
0
1
ticks
30.0

BUTTON
136
385
199
418
NIL
setup
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
254
384
317
417
NIL
go
T
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

PLOT
34
18
480
362
Cell Activity
NIL
NIL
0.0
10.0
0.0
15.0
true
true
"" ""
PENS
"c1" 1.0 0 -16777216 true "" ""
"c2" 1.0 0 -13345367 true "" ""
"c3" 1.0 0 -5825686 true "" ""

BUTTON
778
381
890
414
---->
move-right
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
625
380
734
413
<----
move-left
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
629
455
755
488
NIL
remove-inhibition
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
763
456
888
489
NIL
replace-inhibition
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

SWITCH
113
466
232
499
slide-object
slide-object
0
1
-1000

SWITCH
276
465
397
498
two-objects
two-objects
1
1
-1000

@#$#@#$#@
## WHAT IS IT?

This is a simulation of the process of Lateral Inhibition at the level of tactile perception. The simulation shows a patch of skin and the tactile receptors embedded within it. As objects move on the skin, the receptors become activated and their activity is processed to provide an experience of localized sensation on the skin surface. 
A process of lateral inhibition (LI) ensures that even though the receptive fields of close-by pressure receptors overlap and are co-activated by an object, spatial localization remains sharp. The simulation uses the phenomenon of two-point discrimination to demonstrate the power of LI. 

## HOW IT WORKS

There are a number of tactile receptors on our skin. Their activity can transmit, among other types of information, sensations of pressure, texture and direction of movement. In this simulation, one or two objects move on the skin and can be detected as having sharp edges through the process of LI.   


## HOW TO USE IT

The Setup button creates a thin brown horizontal rectangle which represents the skin. Within it, there are seven red circles representing encapsulated touch receptors that detect mechanical pressure. As objects move over the region of the skin above each receptor, the receptors become active (they turn pink, then light yellow). This activation is passed down to the next layer of cells in the system (cyan circles) which, in turn, send their signals downstream to the central nervous system. The squares receiving their output in the simulation represent our experience of what is happening at the surface of our skin. Gray and black represent no sensation, light yellow represents light sensation, deep yellow represents strong sensation. 

## THINGS TO NOTICE

The process of Lateral Inhibition ensures that perception of edges on the skin is sharp. It is important to notice that a receptor may be active and yet the information it is responding to does not reach the level of experience.
The plot shows the activity of the cyan cells numbered 1 to 3, which could be thalamic relay neurons to the primary somatosensory cortex. 
To observe the effects of LI on the cellular activity of the cyan cells, turn the slide-object switch on and run the simulation twice, one with and one without lateral inhibition. Notice that without lateral inhibition cellular activity does not go below baseline (the level at which the signal starts) at any point in time. With inhibition on, activity has distinct early and a late troughs. 

## THINGS TO TRY
Press the GO button and begin moving the green object over the skin by using the arrow buttons. Notice that our experience of the object on our skin is that of a clear spatial location. The sensory receptor under the object is highly active and its "experience square" is bright yellow. The neighboring experience squares are black, indicating the absence of sensation even though the object is large enough to slightly activate neighboring skin receptors. 
Press the 'remove-inhibition' button and notice that now the experience squares that were black turn light yellow. This indicates that the apparently well-defined spatial location of the object was a result of lateral inhibition. 
Now turn the two-objects switch on and press SETUP and then GO once again. Use the arrow buttons to move the two objects simultaneously. Notice the two distinct points of experience (two bright yellow experience squares surrounded by black squares). This is called 'two-point' discrimination. Different regions of our bodies respond differently to two-point discrimination, with more sensitive areas (fingertips, lips) recognizing the presence of two points even at short distances of one another, while others (back, thigh) require longer distances between stimuli to be detected as different points. 

## CREDITS AND REFERENCES

This model is part of NeuroLab, a set of neuroscience-related simulations in NetLogo written by
 Luis F. Schettino
Psychology Department 
Lafayette College 
Easton, PA, USA. 
https://sites.lafayette.edu/schettil
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 73 73 152
Rectangle -1 true false 180 105 195 120

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

drop
false
0
Polygon -7500403 true true 150 0 75 150 225 150 150 0
Circle -7500403 true true 75 90 148

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

object
false
0
Rectangle -1 true false 195 60 195 105
Rectangle -7500403 true true 45 45 255 225

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

sheep
false
0
Rectangle -7500403 true true 151 225 180 285
Rectangle -7500403 true true 47 225 75 285
Rectangle -7500403 true true 15 75 210 225
Circle -7500403 true true 135 75 150
Circle -16777216 true false 165 76 116

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -1 true false 30 30 270 270
Rectangle -7500403 true true 45 45 255 255

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270

@#$#@#$#@
NetLogo 5.0.4
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 0.0 1.0
0.0 1 1.0 0.0
0.2 0 0.0 1.0
link direction
true
0
Line -7500403 true 150 0 90 30
Line -7500403 true 150 0 210 30

arrow
0.0
-0.2 0 0.0 1.0
0.0 1 1.0 0.0
0.2 0 0.0 1.0
link direction
true
0
Line -7500403 true 150 30 90 60
Line -7500403 true 150 30 210 60

axon2
0.0
-0.2 0 0.0 1.0
0.0 1 1.0 0.0
0.2 0 0.0 1.0
link direction
true
0
Line -7500403 true 150 30 120 0
Line -7500403 true 150 30 180 0

seg
0.0
-0.2 0 0.0 1.0
0.0 1 1.0 0.0
0.2 0 0.0 1.0
link direction
true
0

@#$#@#$#@
0
@#$#@#$#@
